package Menus;

import java.awt.Component;
import javax.swing.JOptionPane;
import java.io.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;
import javax.swing.JComboBox;
import Hero.*;
import Places.*;
import javax.swing.JList;
import javax.swing.UIManager;
import javax.swing.plaf.basic.BasicComboBoxRenderer;
import Tools.*;


public final class Explore extends javax.swing.JFrame 
{
	 
	private final Locations l;
        ArrayList<Village> villages;
        ArrayList<Town> towns;
        ArrayList<City> cities;
        private final Hero hero;
        private FullTownList townList;
        public MapUtil m;
        public Move m1;
        
	
    public Explore(Hero h)
    {
        l = h.getLocationObject();        
        initComponents();
        specialTravel.setVisible(false);
        heroLogArea.setText(h.getTravels());
        visitStore.setEnabled(false);
        rest.setEnabled(false);
        heroStatsArea.append(h.getHeroStats());
        weaponStatsArea.append(h.displayCurrentWeapon());
        currentTownField.setText(h.getHeroPlace());
        hero = h;
        
        villages = l.getVillageList();
        towns = l.getTownList();
        cities = l.getCityList();
        refreshLocation();
        m1 = new Move(h);
        
    }
    
    //<editor-fold defaultstate="collapsed" desc="JCOMBOBOX Override">
    private class FullTownList extends JComboBox<Object>
    {
        @SuppressWarnings("unchecked")
        public FullTownList()
        {
            super();
            super.setRenderer(new FullTownListRenderer());
        }
        
        private Set<Object> disabled_items = new HashSet<>();
        
        public void addItem(Object anObject, boolean disabled)
        {
            super.addItem(anObject);
            if (disabled)
            {
                disabled_items.add(getItemCount() - 1);
            }
        }
        
        @Override
        public void removeAllItems()
        {
            super.removeAllItems();
            disabled_items = new HashSet<>();
        }
        
        @Override
        public void removeItemAt(final int anIndex)
        {
            super.removeItemAt(anIndex);
            disabled_items.remove(anIndex);
        }
        
        @Override
        public void removeItem(final Object anObject)
        {
            for (int i = 0; i < getItemCount(); i++)
            {
                if (getItemAt(i) == anObject)
                {
                    disabled_items.remove(i);
                }
            }
            super.removeItem(anObject);
        }
        
        @Override
        public void setSelectedIndex(int index)
        {
            if(!disabled_items.contains(index))
            {
                if(!disabled_items.contains(index))
                {
                    super.setSelectedIndex(index);
                }
            }
        }
        
        private class FullTownListRenderer extends BasicComboBoxRenderer
        {
            @Override
            public Component getListCellRendererComponent (JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
            {
                if (isSelected)
                {
                    setBackground(list.getSelectionBackground());
                    setForeground(list.getSelectionForeground());
                }
                else
                {
                    setBackground(list.getBackground());
                    setForeground(list.getForeground());
                }
                
                if (disabled_items.contains(index))
                {
                    setBackground(list.getBackground());
                    setForeground(UIManager.getColor("Label.disabledForeground"));
                }
                setFont(list.getFont());
                setText((value == null) ? "" : value.toString());
                return this;
            }
        }
    }//</editor-fold>

    public void getColor()
    {
        m = new MapUtil(hero);
       
    }
    
    public void refreshLocation()
    {
       townList.removeAllItems();
        String name;
        
        for(Village v : villages)
        {
            if(v.getVisited() == true)
            {
                name = v.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true);
                rest.setEnabled(true);
            }
            else
            {
                townList.addItem(v.getName(), true);
            }
            
        }
        
       for(Town t : towns)
        {
            if(t.getVisited() == true)
            {
                name = t.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true);
                 rest.setEnabled(true);
   
            }
            else
            {
                townList.addItem(t.getName(), true);
            }
        }
       
       for(City c : cities)
        {
            if(c.getVisited() == true)
            {
                name = c.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true); 
                 rest.setEnabled(true);
            }
            else
            {
                townList.addItem(c.getName(), true);
            }
        }
       if(!currentTownField.getText().equals(""))
       {
           visitStore.setEnabled(true);
            rest.setEnabled(true);
       }
       else
       {
           visitStore.setEnabled(false);
            rest.setEnabled(false);
       }
        switch (currentTownField.getText()) 
        {
            case "Courtshore Village":
            {
                //specialTravel.setText("Take boat to Falconlake Island");
                specialTravel.setVisible(true);
                break;
            }
            case "Falconlake City":
            {
                specialTravel.setVisible(true);
                //specialTravel.setText("Take boat to Courtshore Village");
                break;
            }
            default:
            {
                specialTravel.setText("");
                specialTravel.setVisible(false);
                break;
            }
        }
               
       
    }    
    
    //x = left , right ----- y = up, down
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        heroStatsPanel = new javax.swing.JPanel();
        heroStatsScroll = new javax.swing.JScrollPane();
        heroStatsArea = new javax.swing.JTextArea();
        weaponStatsPanel = new javax.swing.JPanel();
        weaponStatsScroll = new javax.swing.JScrollPane();
        weaponStatsArea = new javax.swing.JTextArea();
        navagationPanel = new javax.swing.JPanel();
        north = new javax.swing.JButton();
        west = new javax.swing.JButton();
        east = new javax.swing.JButton();
        south = new javax.swing.JButton();
        heroLogPanel = new javax.swing.JPanel();
        heroLogScroll = new javax.swing.JScrollPane();
        heroLogArea = new javax.swing.JTextArea();
        locationPanel = new javax.swing.JPanel();
        currentTownLabel = new javax.swing.JLabel();
        currentTownField = new javax.swing.JTextField();
        differentLable = new javax.swing.JLabel();
        townList = new FullTownList();
        travel = new javax.swing.JButton();
        actionsPanel = new javax.swing.JPanel();
        rest = new javax.swing.JButton();
        visitStore = new javax.swing.JButton();
        checkInventory = new javax.swing.JButton();
        viewMap = new javax.swing.JButton();
        specialTravel = new javax.swing.JButton();
        saveQuitPanel = new javax.swing.JPanel();
        save = new javax.swing.JButton();
        saveQuit = new javax.swing.JButton();
        clearBattleLog = new javax.swing.JButton();
        saveHeroLog = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Explore - Legend of the Secret");
        addWindowFocusListener(new java.awt.event.WindowFocusListener()
        {
            public void windowGainedFocus(java.awt.event.WindowEvent evt)
            {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt)
            {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                formWindowClosing(evt);
            }
        });

        heroStatsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));

        heroStatsArea.setEditable(false);
        heroStatsArea.setColumns(20);
        heroStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStatsArea.setLineWrap(true);
        heroStatsArea.setRows(5);
        heroStatsScroll.setViewportView(heroStatsArea);

        javax.swing.GroupLayout heroStatsPanelLayout = new javax.swing.GroupLayout(heroStatsPanel);
        heroStatsPanel.setLayout(heroStatsPanelLayout);
        heroStatsPanelLayout.setHorizontalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        heroStatsPanelLayout.setVerticalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        weaponStatsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Stats"));

        weaponStatsArea.setEditable(false);
        weaponStatsArea.setColumns(20);
        weaponStatsArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        weaponStatsArea.setLineWrap(true);
        weaponStatsArea.setRows(5);
        weaponStatsScroll.setViewportView(weaponStatsArea);

        javax.swing.GroupLayout weaponStatsPanelLayout = new javax.swing.GroupLayout(weaponStatsPanel);
        weaponStatsPanel.setLayout(weaponStatsPanelLayout);
        weaponStatsPanelLayout.setHorizontalGroup(
            weaponStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(weaponStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        weaponStatsPanelLayout.setVerticalGroup(
            weaponStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, weaponStatsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(weaponStatsScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        navagationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Navagation"));

        north.setText("North");
        north.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                northActionPerformed(evt);
            }
        });

        west.setText("West");
        west.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                westActionPerformed(evt);
            }
        });

        east.setText("East");
        east.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                eastActionPerformed(evt);
            }
        });

        south.setText("South");
        south.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                southActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout navagationPanelLayout = new javax.swing.GroupLayout(navagationPanel);
        navagationPanel.setLayout(navagationPanelLayout);
        navagationPanelLayout.setHorizontalGroup(
            navagationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(navagationPanelLayout.createSequentialGroup()
                .addComponent(west)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(east))
            .addGroup(navagationPanelLayout.createSequentialGroup()
                .addGap(57, 57, 57)
                .addGroup(navagationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(south)
                    .addComponent(north, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(49, Short.MAX_VALUE))
        );
        navagationPanelLayout.setVerticalGroup(
            navagationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(navagationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(north)
                .addGap(9, 9, 9)
                .addGroup(navagationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(west)
                    .addComponent(east))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(south)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        heroLogPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero's Travels"));

        heroLogArea.setEditable(false);
        heroLogArea.setColumns(20);
        heroLogArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroLogArea.setLineWrap(true);
        heroLogArea.setRows(5);
        heroLogScroll.setViewportView(heroLogArea);

        javax.swing.GroupLayout heroLogPanelLayout = new javax.swing.GroupLayout(heroLogPanel);
        heroLogPanel.setLayout(heroLogPanelLayout);
        heroLogPanelLayout.setHorizontalGroup(
            heroLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroLogScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 306, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(34, Short.MAX_VALUE))
        );
        heroLogPanelLayout.setVerticalGroup(
            heroLogPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(heroLogPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(heroLogScroll))
        );

        locationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Location"));

        currentTownLabel.setText("You are currently in:");

        currentTownField.setEditable(false);

        differentLable.setText("Travel to a different town:");

        travel.setText("Travel");
        travel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                travelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout locationPanelLayout = new javax.swing.GroupLayout(locationPanel);
        locationPanel.setLayout(locationPanelLayout);
        locationPanelLayout.setHorizontalGroup(
            locationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(locationPanelLayout.createSequentialGroup()
                .addGroup(locationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(locationPanelLayout.createSequentialGroup()
                        .addComponent(differentLable)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(townList, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(locationPanelLayout.createSequentialGroup()
                        .addComponent(currentTownLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(currentTownField)))
                .addContainerGap())
            .addGroup(locationPanelLayout.createSequentialGroup()
                .addGap(120, 120, 120)
                .addComponent(travel)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        locationPanelLayout.setVerticalGroup(
            locationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(locationPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(locationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(currentTownLabel)
                    .addComponent(currentTownField, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(locationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(differentLable)
                    .addComponent(townList, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(travel))
        );

        actionsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        rest.setText("Rest");
        rest.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                restActionPerformed(evt);
            }
        });

        visitStore.setText("Visit the Store");
        visitStore.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                visitStoreActionPerformed(evt);
            }
        });

        checkInventory.setText("Check Inventory");
        checkInventory.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                checkInventoryActionPerformed(evt);
            }
        });

        viewMap.setText("View Map");
        viewMap.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                viewMapActionPerformed(evt);
            }
        });

        specialTravel.setText("Take the Boat");
        specialTravel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                specialTravelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout actionsPanelLayout = new javax.swing.GroupLayout(actionsPanel);
        actionsPanel.setLayout(actionsPanelLayout);
        actionsPanelLayout.setHorizontalGroup(
            actionsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(actionsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(actionsPanelLayout.createSequentialGroup()
                        .addComponent(rest, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(viewMap))
                    .addComponent(visitStore, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(checkInventory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(specialTravel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(3, 3, 3))
        );
        actionsPanelLayout.setVerticalGroup(
            actionsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(actionsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(actionsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rest)
                    .addComponent(viewMap))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(visitStore)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(checkInventory)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(specialTravel, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(12, 12, 12))
        );

        saveQuitPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Save/Quit"));

        save.setText("Save Progress");
        save.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                saveActionPerformed(evt);
            }
        });

        saveQuit.setText("Save and Quit");
        saveQuit.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                saveQuitActionPerformed(evt);
            }
        });

        clearBattleLog.setText("Clear the Hero's Log");
        clearBattleLog.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearBattleLogActionPerformed(evt);
            }
        });

        saveHeroLog.setText("Save the Hero's Log");
        saveHeroLog.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                saveHeroLogActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout saveQuitPanelLayout = new javax.swing.GroupLayout(saveQuitPanel);
        saveQuitPanel.setLayout(saveQuitPanelLayout);
        saveQuitPanelLayout.setHorizontalGroup(
            saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(saveQuitPanelLayout.createSequentialGroup()
                .addGroup(saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(saveQuitPanelLayout.createSequentialGroup()
                        .addComponent(save)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(clearBattleLog, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(saveQuitPanelLayout.createSequentialGroup()
                        .addComponent(saveQuit)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(saveHeroLog)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        saveQuitPanelLayout.setVerticalGroup(
            saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, saveQuitPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(clearBattleLog)
                    .addComponent(save))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(saveQuitPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveHeroLog)
                    .addComponent(saveQuit))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(heroLogPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(heroStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(weaponStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(navagationPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(actionsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(saveQuitPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(locationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(heroStatsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(heroLogPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(weaponStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(navagationPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(actionsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(locationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(saveQuitPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public boolean battleTrue()
    {
        boolean battle = false;
        MapUtil mu = new MapUtil(hero);
        int g = mu.getGreen();

        if(g == 230)
        {
            battle = false;
        }
        if(g == 231)
        {
         
            RDN rd = new RDN(12);
            int r1 = rd.RN();
            int r2 = rd.RN();
            if(r1 == r2)
            {
                battle = true;
                
            }
        }
        if(g == 210)
        {
            
             RDN rd = new RDN(7);
            int r1 = rd.RN();
            int r2 = rd.RN();
            if(r1 == r2)
            {
                battle = true;
                
            }
        }
        if(g == 190)
        {
             RDN rd = new RDN(5);
            int r1 = rd.RN();
            int r2 = rd.RN();
            if(r1 == r2)
            {
                battle = true;
                
            }
        }
        
        return battle;
    }
    
    public void randomLoot()
    {
        RDN r = new RDN(30);
        int rloot = r.RN();
        
        if(rloot == 5 || rloot == 21)
        {
            Item i = new Item(hero.getLevel());
            hero.addItem(i);
            heroLogArea.append("\n\n You tripped over something.\n You found a new item.\n" + i.getItemStats() + "\n\n");
        }
        
    }
    
    
    public void startBattle()
    {
        JOptionPane.showMessageDialog(null,"You have encountered a random enemy, prepare for battle.");
        heroLogArea.append("\nYou battled an enemy\n");
        String travels = heroLogArea.getText();
        hero.setRestCounter(hero.getRestCounter() - .5);
        hero.setStoreStock(hero.getStoreStock() - .5);
        hero.setTravels(travels);
        Explore.this.dispose();
        Battle bg = new Battle(hero);
        bg.setLocationRelativeTo(null);
        bg.setVisible(true);
    }
    

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       weaponStatsArea.setText(hero.displayCurrentWeapon());
       heroStatsArea.setText(hero.getHeroStats());
       currentTownField.setText(hero.getHeroPlace());
    }//GEN-LAST:event_formWindowGainedFocus

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    
        Object[] options = {"Quit Without Saving","Save and Quit", "Return to the Game"};
        int result = JOptionPane.showOptionDialog(null, "Are you sure you want to quit without saving?","Quit?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[2]);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
       if(result == JOptionPane.NO_OPTION)
       {
           String gs = hero.getName() + ".ser";
        ObjectOutputStream oos1;
        try
        {
            oos1 = new ObjectOutputStream (new FileOutputStream(gs));
            oos1.writeObject(hero);
            oos1.flush();
            oos1.close();
            String message = "The hero with the name " + hero.getName() + " has been saved with the filename " + gs + ".";
            JOptionPane.showMessageDialog(null,message);
            System.exit(0);
            
        }
        catch(IOException ioe)
        {
            
        }
       }
    }//GEN-LAST:event_formWindowClosing

    private void eastActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_eastActionPerformed
    {//GEN-HEADEREND:event_eastActionPerformed
//        RDN rdnenc = new RDN(20);
//        int rdenc = rdnenc.RN();
//        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
//        {
//            startBattle();
//
//        }
        boolean battle = battleTrue();
        
        if(battle)
        {
            startBattle();
        }
        else
        {
            String move = hero.move("E");
            switch (move)
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n.");
                    break;
                }
               
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append(move + "\n");
                    break;
                }
            }
        }
        currentTownField.setText(hero.getHeroPlace());
        refreshLocation();
        hero.setRestCounter(hero.getRestCounter() - .2);
        hero.setStoreStock(hero.getStoreStock() - .2);
        randomLoot();
        getColor();
    }//GEN-LAST:event_eastActionPerformed

    private void southActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_southActionPerformed
    {//GEN-HEADEREND:event_southActionPerformed
//        RDN rdnenc = new RDN(20);
//        int rdenc = rdnenc.RN();
//        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
//        {
//            startBattle();
//
//        }
        
        boolean battle = battleTrue();
        if(battle)
        {
            startBattle();
        }
        else
        {
            String move = hero.move("S");
            switch (move)
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NWB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel north west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NEB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel north east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SWB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel south west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SEB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel south east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append(move + "\n");
                    break;
                }
            }
        }
        currentTownField.setText(hero.getHeroPlace());
        refreshLocation();
        hero.setRestCounter(hero.getRestCounter() - .2);
        hero.setStoreStock(hero.getStoreStock() - .2);
        randomLoot();
        getColor();
    }//GEN-LAST:event_southActionPerformed

    private void northActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_northActionPerformed
    {//GEN-HEADEREND:event_northActionPerformed
//        RDN rdnenc = new RDN(20);
//        int rdenc = rdnenc.RN();
//        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
//        {
//            startBattle();
//            //
//        }
        
        boolean battle = battleTrue();
        if(battle)
        {
            startBattle();
        }
        else
        {
            String move = hero.move("N");
            switch (move)
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append(move + "\n");
                    break;
                }
            }
        }
        currentTownField.setText(hero.getHeroPlace());
        refreshLocation();
        hero.setRestCounter(hero.getRestCounter() - .2);
        hero.setStoreStock(hero.getStoreStock() - .2);
        randomLoot();
       // getColor();
    }//GEN-LAST:event_northActionPerformed

    private void westActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_westActionPerformed
    {//GEN-HEADEREND:event_westActionPerformed
//        RDN rdnenc = new RDN(20);
//        int rdenc = rdnenc.RN();
//        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
//        {
//            startBattle();
//
//        }
        
        boolean battle = battleTrue();
        if(battle)
        {
            startBattle();
        }
        else
        {
            String move = hero.move("W");
            switch (move)
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    heroLogArea.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    heroLogArea.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }              
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    heroLogArea.append(move + "\n");
                    break;
                }
            }
        }
        currentTownField.setText(hero.getHeroPlace());
        refreshLocation();
        hero.setRestCounter(hero.getRestCounter() - .2);
        hero.setStoreStock(hero.getStoreStock() - .2);
        randomLoot();
        getColor();
    }//GEN-LAST:event_westActionPerformed


    private void travelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_travelActionPerformed
    {//GEN-HEADEREND:event_travelActionPerformed
        Object[] options = {"Yes","No"};
        int n = JOptionPane.showOptionDialog(null,"If you want to travel it will cost " + (hero.displayCurrency(35 * hero.getLevel())) + ". Do you want to continue?", "Travel", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
        if(n==0)
        {

            if((hero.getMoney() - (35 * hero.getLevel())) >= 0)
            {
                int town = townList.getSelectedIndex();
                Object tName = townList.getItemAt(town);
                String townName = tName.toString();
                m1.setHeroPlace(townName);
                hero.setHeroPlaceName(townName);
                currentTownField.setText(hero.getHeroPlace());
                hero.setMoney(hero.getMoney() - (35 * hero.getLevel()));
                refreshLocation();
            }
            else
            {
                JOptionPane.showMessageDialog(null,"You do not have enough money.");
            }
        }

    }//GEN-LAST:event_travelActionPerformed

    private void specialTravelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_specialTravelActionPerformed
    {//GEN-HEADEREND:event_specialTravelActionPerformed
        if(specialTravel.getText().equals("Take boat to Falconlake Island"))
        {
            JOptionPane.showMessageDialog(null,"Take the boat to Falconlake Island?");
            m1.setHeroPlace("Falconlake City");
            currentTownField.setText(hero.getHeroPlace());

        }
        if(specialTravel.getText().equals("Take boat to Courtshore Village"))
        {
            m1.setHeroPlace("Courtshore Village");
            JOptionPane.showMessageDialog(null,"Take the boat to Falconlake Island?");
            currentTownField.setText(hero.getHeroPlace());
        }
        refreshLocation();
    }//GEN-LAST:event_specialTravelActionPerformed

    private void saveQuitActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveQuitActionPerformed
    {//GEN-HEADEREND:event_saveQuitActionPerformed

        FileManagement fm = new FileManagement();
        fm.saveFile(hero);        
        System.exit(0);
    }//GEN-LAST:event_saveQuitActionPerformed

    private void restActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_restActionPerformed
    {//GEN-HEADEREND:event_restActionPerformed

        Object[] options = {"Yes","No"};
        int n = JOptionPane.showOptionDialog(null,"If you want to rest it will cost " + (hero.displayCurrency(35 * hero.getLevel())) + ". Do you want to continue?", "Rest?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
        if(n==0)
        {
            if(((hero.getMoney() - (35*hero.getLevel())) >= 0) && (hero.getDefaultHealth() <= hero.getHealth()))
            JOptionPane.showMessageDialog(null,hero.rest());
            else
            JOptionPane.showMessageDialog(null, "You do not have enough money or you don't need to rest.");
        }

    }//GEN-LAST:event_restActionPerformed

    private void saveActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveActionPerformed
    {//GEN-HEADEREND:event_saveActionPerformed

        FileManagement fm = new FileManagement();
        fm.saveFile(hero);
        
    }//GEN-LAST:event_saveActionPerformed

    private void checkInventoryActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_checkInventoryActionPerformed
    {//GEN-HEADEREND:event_checkInventoryActionPerformed
        Inventory ig = new Inventory(hero);
        ig.setLocationRelativeTo(null);
        ig.setVisible(true);
        weaponStatsArea.setText(hero.displayCurrentWeapon());

    }//GEN-LAST:event_checkInventoryActionPerformed

    private void viewMapActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_viewMapActionPerformed
    {//GEN-HEADEREND:event_viewMapActionPerformed
        Map mg = new Map(hero);
        mg.player.setLocation(hero.getHeroLocationPoint());
        mg.setLocationRelativeTo(null);
        mg.setVisible(true);
        
    }//GEN-LAST:event_viewMapActionPerformed

    private void visitStoreActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_visitStoreActionPerformed
    {//GEN-HEADEREND:event_visitStoreActionPerformed

        Store sg = new Store(hero, hero.getHeroPlace());
        sg.setLocationRelativeTo(null);
        sg.setVisible(true);
    }//GEN-LAST:event_visitStoreActionPerformed

    private void clearBattleLogActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_clearBattleLogActionPerformed
    {//GEN-HEADEREND:event_clearBattleLogActionPerformed
        heroLogArea.setText("");
        hero.setTravels("");
    }//GEN-LAST:event_clearBattleLogActionPerformed

    private void saveHeroLogActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_saveHeroLogActionPerformed
    {//GEN-HEADEREND:event_saveHeroLogActionPerformed
        String travels = heroLogArea.getText();
        hero.setTravels(travels);
        FileManagement fm = new FileManagement();
        fm.saveTxt(hero.getTravels(), hero.getName());
    }//GEN-LAST:event_saveHeroLogActionPerformed
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel actionsPanel;
    private javax.swing.JButton checkInventory;
    private javax.swing.JButton clearBattleLog;
    private javax.swing.JTextField currentTownField;
    private javax.swing.JLabel currentTownLabel;
    private javax.swing.JLabel differentLable;
    private javax.swing.JButton east;
    private javax.swing.JTextArea heroLogArea;
    private javax.swing.JPanel heroLogPanel;
    private javax.swing.JScrollPane heroLogScroll;
    private javax.swing.JTextArea heroStatsArea;
    private javax.swing.JPanel heroStatsPanel;
    private javax.swing.JScrollPane heroStatsScroll;
    private javax.swing.JPanel locationPanel;
    private javax.swing.JPanel navagationPanel;
    private javax.swing.JButton north;
    private javax.swing.JButton rest;
    private javax.swing.JButton save;
    private javax.swing.JButton saveHeroLog;
    private javax.swing.JButton saveQuit;
    private javax.swing.JPanel saveQuitPanel;
    private javax.swing.JButton south;
    private javax.swing.JButton specialTravel;
    /*
    private javax.swing.JComboBox townList;
    */
    private javax.swing.JButton travel;
    private javax.swing.JButton viewMap;
    private javax.swing.JButton visitStore;
    private javax.swing.JTextArea weaponStatsArea;
    private javax.swing.JPanel weaponStatsPanel;
    private javax.swing.JScrollPane weaponStatsScroll;
    private javax.swing.JButton west;
    // End of variables declaration//GEN-END:variables
}
