package Menus;

import Hero.*;

import java.util.Arrays;
import java.util.Collections;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JOptionPane;

public class Inventory extends javax.swing.JFrame 
{
    public Inventory(Hero hero) 
    {  
        h = hero;
        
        weaponSelection = new JList<>();
        itemSelection = new JList<>();
        weaponSelection.setModel(weaponModel);
        itemSelection.setModel(itemModel);
        initComponents();
        showInvWep();
    }
    
    public final void showInvWep()
    {        
        currentWeapon.setText(h.displayCurrentWeapon());   
        heroStats.setText(h.getHeroStats());
        currentWeapon1.setText(h.displayCurrentWeapon());   
        heroStats1.setText(h.getHeroStats());
        weaponSlots.setText(h.getWeaponInventoryCounter() + "");
        itemSlot.setText(h.getItemInventoryCounter() + "");
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        weaponModel.clear();
        itemModel.clear();
        itemSelection.setModel(itemModel);
        for(int i = 0; i < h.getWeaponInventorySize(); i++)
        {
           Weapon w = h.getWeaponObject(i);     
           weaponModel.addElement(w.getName());
        }
        for(int z = 0; z <h.getItemInventorySize(); z++)
        {
            Item i = h.getItemObject(z);
            itemModel.addElement(i.getItemName());
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        inventoryTabs = new javax.swing.JTabbedPane();
        weaponTabPanel = new javax.swing.JPanel();
        instrucWepLbl = new javax.swing.JLabel();
        weaponActionPanel = new javax.swing.JPanel();
        removeWeapon = new javax.swing.JButton();
        repairWeapon = new javax.swing.JButton();
        sellWeapon = new javax.swing.JButton();
        switchWeapon = new javax.swing.JButton();
        clearSelection = new javax.swing.JButton();
        closeInventory = new javax.swing.JButton();
        weaponEquipedPanel = new javax.swing.JPanel();
        currentWeaponScroll = new javax.swing.JScrollPane();
        currentWeapon = new javax.swing.JTextArea();
        weaponSelectedPanel = new javax.swing.JPanel();
        selectedWeaponScroll = new javax.swing.JScrollPane();
        selectedWeapon = new javax.swing.JTextArea();
        weaponSelectionPanel = new javax.swing.JPanel();
        weaponSelectionScroll = new javax.swing.JScrollPane();
        /*
        weaponSelection = ;//new javax.swing.JList();
        */
        heroStatsPanel = new javax.swing.JPanel();
        heroStatScroll = new javax.swing.JScrollPane();
        heroStats = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        weaponSlots = new javax.swing.JTextField();
        itemTabPanel = new javax.swing.JPanel();
        instrucItemLbl = new javax.swing.JLabel();
        itemActionPanel = new javax.swing.JPanel();
        removeItem = new javax.swing.JButton();
        useItem = new javax.swing.JButton();
        clearSelection1 = new javax.swing.JButton();
        closeInventory1 = new javax.swing.JButton();
        sellItem = new javax.swing.JButton();
        selectedItemPanel = new javax.swing.JPanel();
        selectedItemScroll = new javax.swing.JScrollPane();
        selectedItem = new javax.swing.JTextArea();
        heroStatPanel1 = new javax.swing.JPanel();
        heroStatScroll1 = new javax.swing.JScrollPane();
        heroStats1 = new javax.swing.JTextArea();
        weaponEquipedPanel1 = new javax.swing.JPanel();
        currentWeaponScroll1 = new javax.swing.JScrollPane();
        currentWeapon1 = new javax.swing.JTextArea();
        itemSelectionPanel = new javax.swing.JPanel();
        itemSelectionScroll = new javax.swing.JScrollPane();
        /*
        itemSelection = new javax.swing.JList();
        */
        itemSlotPanel = new javax.swing.JPanel();
        itemSlot = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Inventory - Legend of the Secret");
        setPreferredSize(new java.awt.Dimension(765, 500));
        setResizable(false);

        inventoryTabs.setBorder(javax.swing.BorderFactory.createTitledBorder("Inventory"));

        instrucWepLbl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        instrucWepLbl.setText("<html><center>Please select a weapon in the list and then select an action to perform. </center> </html>");
        instrucWepLbl.setAutoscrolls(true);
        instrucWepLbl.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instrucWepLbl.setMaximumSize(new java.awt.Dimension(201, 14));
        instrucWepLbl.setMinimumSize(new java.awt.Dimension(201, 14));
        instrucWepLbl.setPreferredSize(new java.awt.Dimension(201, 14));

        weaponActionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        removeWeapon.setText("Remove selected weapons");
        removeWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                removeWeaponActionPerformed(evt);
            }
        });

        repairWeapon.setText("Repair equipped weapon");
        repairWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                repairWeaponActionPerformed(evt);
            }
        });

        sellWeapon.setText("Sell selected weapons");
        sellWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sellWeaponActionPerformed(evt);
            }
        });

        switchWeapon.setText("Switch your current weapon");
        switchWeapon.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                switchWeaponActionPerformed(evt);
            }
        });

        clearSelection.setText("Clear Selections");
        clearSelection.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearSelectionActionPerformed(evt);
            }
        });

        closeInventory.setText("Close Inventory");
        closeInventory.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                closeInventoryActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout weaponActionPanelLayout = new javax.swing.GroupLayout(weaponActionPanel);
        weaponActionPanel.setLayout(weaponActionPanelLayout);
        weaponActionPanelLayout.setHorizontalGroup(
            weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(sellWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(clearSelection, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(weaponActionPanelLayout.createSequentialGroup()
                        .addGroup(weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(switchWeapon)
                            .addGroup(weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(repairWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(removeWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(closeInventory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        weaponActionPanelLayout.setVerticalGroup(
            weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(switchWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(removeWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(repairWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sellWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(clearSelection)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(closeInventory)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        weaponEquipedPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Equipped Weapon"));

        currentWeapon.setEditable(false);
        currentWeapon.setColumns(20);
        currentWeapon.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        currentWeapon.setRows(5);
        currentWeaponScroll.setViewportView(currentWeapon);

        javax.swing.GroupLayout weaponEquipedPanelLayout = new javax.swing.GroupLayout(weaponEquipedPanel);
        weaponEquipedPanel.setLayout(weaponEquipedPanelLayout);
        weaponEquipedPanelLayout.setHorizontalGroup(
            weaponEquipedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 238, Short.MAX_VALUE)
            .addGroup(weaponEquipedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponEquipedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(currentWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 218, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponEquipedPanelLayout.setVerticalGroup(
            weaponEquipedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 127, Short.MAX_VALUE)
            .addGroup(weaponEquipedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponEquipedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(currentWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 105, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponSelectedPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Weapon Selected"));

        selectedWeapon.setEditable(false);
        selectedWeapon.setColumns(20);
        selectedWeapon.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedWeapon.setRows(5);
        selectedWeaponScroll.setViewportView(selectedWeapon);

        javax.swing.GroupLayout weaponSelectedPanelLayout = new javax.swing.GroupLayout(weaponSelectedPanel);
        weaponSelectedPanel.setLayout(weaponSelectedPanelLayout);
        weaponSelectedPanelLayout.setHorizontalGroup(
            weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 219, Short.MAX_VALUE)
            .addGroup(weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponSelectedPanelLayout.setVerticalGroup(
            weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 104, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponSelectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Selection"));

        weaponSelection.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                weaponSelectionValueChanged(evt);
            }
        });
        weaponSelectionScroll.setViewportView(weaponSelection);

        javax.swing.GroupLayout weaponSelectionPanelLayout = new javax.swing.GroupLayout(weaponSelectionPanel);
        weaponSelectionPanel.setLayout(weaponSelectionPanelLayout);
        weaponSelectionPanelLayout.setHorizontalGroup(
            weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 289, Short.MAX_VALUE)
            .addGroup(weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 269, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponSelectionPanelLayout.setVerticalGroup(
            weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        heroStatsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));

        heroStats.setEditable(false);
        heroStats.setColumns(20);
        heroStats.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStats.setRows(5);
        heroStatScroll.setViewportView(heroStats);

        javax.swing.GroupLayout heroStatsPanelLayout = new javax.swing.GroupLayout(heroStatsPanel);
        heroStatsPanel.setLayout(heroStatsPanelLayout);
        heroStatsPanelLayout.setHorizontalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 210, Short.MAX_VALUE)
            .addGroup(heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );
        heroStatsPanelLayout.setVerticalGroup(
            heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 206, Short.MAX_VALUE)
            .addGroup(heroStatsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatsPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Slots Free"));

        weaponSlots.setEditable(false);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 132, Short.MAX_VALUE)
            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jPanel4Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSlots, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 52, Short.MAX_VALUE)
            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(jPanel4Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSlots, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );

        javax.swing.GroupLayout weaponTabPanelLayout = new javax.swing.GroupLayout(weaponTabPanel);
        weaponTabPanel.setLayout(weaponTabPanelLayout);
        weaponTabPanelLayout.setHorizontalGroup(
            weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(weaponTabPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(weaponSelectedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(weaponEquipedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addGap(30, 30, 30)
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(instrucWepLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(16, 16, 16))
            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, weaponTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(weaponSelectionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(heroStatsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(weaponActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        weaponTabPanelLayout.setVerticalGroup(
            weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, weaponTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(heroStatsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(weaponSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(weaponActionPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(weaponSelectedPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(weaponEquipedPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addGap(14, 14, 14)
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(instrucWepLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        inventoryTabs.addTab("Weapons", weaponTabPanel);

        instrucItemLbl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        instrucItemLbl.setText("<html><center>Please select a item in the list and then select an action to perform. </center> </html>");
        instrucItemLbl.setAutoscrolls(true);
        instrucItemLbl.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instrucItemLbl.setMaximumSize(new java.awt.Dimension(201, 14));
        instrucItemLbl.setMinimumSize(new java.awt.Dimension(201, 14));
        instrucItemLbl.setPreferredSize(new java.awt.Dimension(201, 14));

        itemActionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));
        itemActionPanel.setPreferredSize(new java.awt.Dimension(199, 213));

        removeItem.setText("Remove selected items");
        removeItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                removeItemActionPerformed(evt);
            }
        });

        useItem.setText("Use selected items");
        useItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                useItemActionPerformed(evt);
            }
        });

        clearSelection1.setText("Clear Selections");
        clearSelection1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                clearSelection1ActionPerformed(evt);
            }
        });

        closeInventory1.setText("Close Inventory");
        closeInventory1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                closeInventory1ActionPerformed(evt);
            }
        });

        sellItem.setText("Sell selected items");
        sellItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sellItemActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout itemActionPanelLayout = new javax.swing.GroupLayout(itemActionPanel);
        itemActionPanel.setLayout(itemActionPanelLayout);
        itemActionPanelLayout.setHorizontalGroup(
            itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(useItem, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(closeInventory1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(clearSelection1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(removeItem, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                    .addComponent(sellItem, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        itemActionPanelLayout.setVerticalGroup(
            itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(useItem)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(removeItem)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sellItem)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(clearSelection1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(closeInventory1)
                .addContainerGap())
        );

        selectedItemPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Item Selected"));
        selectedItemPanel.setPreferredSize(new java.awt.Dimension(231, 150));

        selectedItem.setEditable(false);
        selectedItem.setColumns(20);
        selectedItem.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedItem.setRows(5);
        selectedItemScroll.setViewportView(selectedItem);

        javax.swing.GroupLayout selectedItemPanelLayout = new javax.swing.GroupLayout(selectedItemPanel);
        selectedItemPanel.setLayout(selectedItemPanelLayout);
        selectedItemPanelLayout.setHorizontalGroup(
            selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 219, Short.MAX_VALUE)
            .addGroup(selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(selectedItemPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedItemScroll)
                    .addContainerGap()))
        );
        selectedItemPanelLayout.setVerticalGroup(
            selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 127, Short.MAX_VALUE)
            .addGroup(selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, selectedItemPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedItemScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        heroStatPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Hero Stats"));
        heroStatPanel1.setPreferredSize(new java.awt.Dimension(222, 229));

        heroStats1.setEditable(false);
        heroStats1.setColumns(20);
        heroStats1.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        heroStats1.setRows(5);
        heroStatScroll1.setViewportView(heroStats1);

        javax.swing.GroupLayout heroStatPanel1Layout = new javax.swing.GroupLayout(heroStatPanel1);
        heroStatPanel1.setLayout(heroStatPanel1Layout);
        heroStatPanel1Layout.setHorizontalGroup(
            heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 210, Short.MAX_VALUE)
            .addGroup(heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        heroStatPanel1Layout.setVerticalGroup(
            heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(heroStatScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponEquipedPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Equiped"));
        weaponEquipedPanel1.setPreferredSize(new java.awt.Dimension(250, 150));

        currentWeapon1.setEditable(false);
        currentWeapon1.setColumns(20);
        currentWeapon1.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        currentWeapon1.setRows(5);
        currentWeaponScroll1.setViewportView(currentWeapon1);

        javax.swing.GroupLayout weaponEquipedPanel1Layout = new javax.swing.GroupLayout(weaponEquipedPanel1);
        weaponEquipedPanel1.setLayout(weaponEquipedPanel1Layout);
        weaponEquipedPanel1Layout.setHorizontalGroup(
            weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 238, Short.MAX_VALUE)
            .addGroup(weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponEquipedPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(currentWeaponScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponEquipedPanel1Layout.setVerticalGroup(
            weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 127, Short.MAX_VALUE)
            .addGroup(weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, weaponEquipedPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(currentWeaponScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 105, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        itemSelectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Item Selection"));
        itemSelectionPanel.setPreferredSize(new java.awt.Dimension(301, 229));

        itemSelection.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                itemSelectionValueChanged(evt);
            }
        });
        itemSelectionScroll.setViewportView(itemSelection);

        javax.swing.GroupLayout itemSelectionPanelLayout = new javax.swing.GroupLayout(itemSelectionPanel);
        itemSelectionPanel.setLayout(itemSelectionPanelLayout);
        itemSelectionPanelLayout.setHorizontalGroup(
            itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 289, Short.MAX_VALUE)
            .addGroup(itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(itemSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 269, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        itemSelectionPanelLayout.setVerticalGroup(
            itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 206, Short.MAX_VALUE)
            .addGroup(itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(itemSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        itemSlotPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Item Slots Free"));
        itemSlotPanel.setPreferredSize(new java.awt.Dimension(144, 75));

        itemSlot.setEditable(false);

        javax.swing.GroupLayout itemSlotPanelLayout = new javax.swing.GroupLayout(itemSlotPanel);
        itemSlotPanel.setLayout(itemSlotPanelLayout);
        itemSlotPanelLayout.setHorizontalGroup(
            itemSlotPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemSlotPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(itemSlot, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
                .addContainerGap())
        );
        itemSlotPanelLayout.setVerticalGroup(
            itemSlotPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemSlotPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(itemSlot, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout itemTabPanelLayout = new javax.swing.GroupLayout(itemTabPanel);
        itemTabPanel.setLayout(itemTabPanelLayout);
        itemTabPanelLayout.setHorizontalGroup(
            itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemTabPanelLayout.createSequentialGroup()
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(itemSelectionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(heroStatPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(itemActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addComponent(selectedItemPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(weaponEquipedPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(itemTabPanelLayout.createSequentialGroup()
                                .addGap(30, 30, 30)
                                .addComponent(itemSlotPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, itemTabPanelLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(instrucItemLbl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap())
        );
        itemTabPanelLayout.setVerticalGroup(
            itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemTabPanelLayout.createSequentialGroup()
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(itemActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(heroStatPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(itemSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(selectedItemPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(weaponEquipedPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addGap(254, 254, 254)
                        .addComponent(itemSlotPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(instrucItemLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        inventoryTabs.addTab("Items", itemTabPanel);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(inventoryTabs)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(inventoryTabs, javax.swing.GroupLayout.PREFERRED_SIZE, 471, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public Integer[] sortDesc(int[] aryNums)
    {
           
           Integer[] integerArray = new Integer[aryNums.length];
            
           for(int i = 0; i<aryNums.length; i++)
           {
               integerArray[i] = new Integer(aryNums[i]);
           }
           Arrays.sort(integerArray, Collections.reverseOrder());
        return integerArray;
    }
    
    private void itemSelectionValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_itemSelectionValueChanged
        try
        {
            Item i = h.getItemObject(itemSelection.getSelectedIndex());
            selectedItem.setText(i.displayStoreItems());
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {

        }
    }//GEN-LAST:event_itemSelectionValueChanged

    private void sellItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sellItemActionPerformed

        //int remitem = itemSelection.getSelectedIndex();
        try
        {
            int[] a = itemSelection.getSelectedIndices();
            Integer[] arr = sortDesc(a);
            for (Integer arr1 : arr)
            {
                int remitem = arr1;
                Item i = h.getItemObject(remitem);
                String message = "Are you sure you want to sell your " + i.getName() + " for " + h.displayCurrency(i.getValue()) + ".";
                Object[] options = {"Yes","No"};
                int n = JOptionPane.showOptionDialog(null,message, "Sell item?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
                if(n==0)
                {
                    double newmoney = h.getMoney() + i.getValue();
                    h.setMoney(newmoney);
                    h.destroyItem(remitem);
                }
            }
        }
        catch(IndexOutOfBoundsException aioobe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }

        showInvWep();

    }//GEN-LAST:event_sellItemActionPerformed

    private void closeInventory1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeInventory1ActionPerformed
        Inventory.this.dispose();
    }//GEN-LAST:event_closeInventory1ActionPerformed

    private void clearSelection1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearSelection1ActionPerformed
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        selectedWeapon.setText("");
        selectedItem.setText("");
    }//GEN-LAST:event_clearSelection1ActionPerformed

    private void useItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_useItemActionPerformed
        try
        {

            int[] a = itemSelection.getSelectedIndices();
            Integer[] itemnumA = sortDesc(a);
            for (Integer itemnumA1 : itemnumA)
            {
                int itemnum = itemnumA1;
                Item i = h.getItemObject(itemnum);
                Item eItem = new Item(i.getIC());
                String effectPassed = eItem.getPassEffect();
                String eCat = eItem.getCategory();
                String eName = eItem.getName();
                switch(eCat)
                {
                    case "Anti-status":
                    {
                        if(effectPassed.equals("TRUE"))
                        {
                            if(eName.equals(h.getStatus()))
                            {
                                h.setStatus("Normal");
                                h.destroyItem(itemnum);
                            }
                            else
                            {
                                JOptionPane.showMessageDialog(null,"This item has no effect.");
                                h.destroyItem(itemnum);
                            }
                        }
                        else
                        {
                            JOptionPane.showMessageDialog(null,"Item failed");
                            h.destroyItem(itemnum);
                        }
                        break;
                    }

                    case "Point Enhancers":
                    {
                        if(eName.equals("Potion"))
                        {
                            int health1 = h.getHealth();
                            int health2 = Integer.parseInt(effectPassed);
                            int healthtotal = health1 + health2;
                            h.setHealth(healthtotal);
                            String message1 = "Your health is now at " + healthtotal;
                            JOptionPane.showMessageDialog(null,message1);
                            h.destroyItem(itemnum);
                            break;
                        }
                        if(eName.equals("Attack"))
                        {
                            int attack1 = h.getAttack();
                            int attack2 = Integer.parseInt(effectPassed);
                            int attacktotal = attack1 + attack2;
                            h.setAttack(attacktotal);
                            String message1 = "Your attack is now at " + attacktotal;
                            JOptionPane.showMessageDialog(null, message1);
                            h.destroyItem(itemnum);
                            break;
                        }
                        if(eName.equals("WeaponHealth"))
                        {
                            Weapon w = h.getWeaponObject(0);
                            int wephealth1 = w.getHealth();
                            int wephealth2 = Integer.parseInt(effectPassed);
                            int wephealthtotal = wephealth1 + wephealth2;
                            h.upgradeWeaponHealth(wephealth2);
                            String message1 = "Your weapon health is now at " + wephealthtotal;
                            JOptionPane.showMessageDialog(null, message1);
                            h.destroyItem(itemnum);
                            break;
                        }
                        if(eName.equals("WeaponAttack"))
                        {
                            Weapon w = h.getWeaponObject(0);
                            int wepatk1 = w.getAttack();
                            int wepatk2 = Integer.parseInt(effectPassed);
                            int wepatktotal = wepatk1 + wepatk2;
                            h.upgradeWeaponAttack(wepatk2);
                            String message1 = "Your weapon attack is now at " + wepatktotal;
                            JOptionPane.showMessageDialog(null, message1);
                            h.destroyItem(itemnum);
                            break;
                        }
                    }
                    case "Rare":
                    {
                        if(eName.equals("CureAll"))
                        {
                            if(effectPassed.equals("TRUE"))
                            {
                                h.setStatus("Normal");
                                h.destroyItem(itemnum);
                                break;
                            }
                            else
                            {
                                JOptionPane.showMessageDialog(null,"Item failed.");
                                h.destroyItem(itemnum);
                                break;
                            }
                        }

                        if(eName.equals("ExpIncrease"))
                        {
                            int exp1 = h.getExp();
                            int exp2 = Integer.parseInt(effectPassed);
                            int exptotal = exp1  + exp2;
                            h.setExp(exp2);
                            String message1 = "Your exp is now at " + exptotal;
                            JOptionPane.showMessageDialog(null,message1);
                            h.destroyItem(itemnum);
                            break;

                        }
                        if(eName.equals("WeaponInventoryIncrease"))
                        {
                            h.setBonusWeaponInventory(h.getBonusWeaponInventory() + 1);
                            h.setWeaponInventoryCounter(h.getWeaponInventoryCounter() + 1);
                            JOptionPane.showMessageDialog(null,"Your weapon inventory space has increased.");
                            h.destroyItem(itemnum);
                            break;
                        }

                        if(eName.equals("ItemInventoryIncrease"))
                        {
                            h.setBonusItemInventory(h.getBonusItemInventory() + 1);
                            h.setItemInventoryCounter(h.getItemInventoryCounter() + 1);
                            JOptionPane.showMessageDialog(null,"Your weapon inventory space has increased.");
                            h.destroyItem(itemnum);
                            break;
                        }

                        else
                        {
                            break;
                        }
                    }

                    case "Other":
                    {
                        JOptionPane.showMessageDialog(null,"This has no effect yet.");
                        break;
                    }

                    case "NULL":
                    {
                        JOptionPane.showMessageDialog(null,"Please select a slot that has an item in it.");
                        break;
                    }

                }
            }
            showInvWep();
        }

        catch(NullPointerException npe)
        {
            JOptionPane.showMessageDialog(null,"This has no effect yet.");
        }

        catch(NumberFormatException nfe)
        {
        }
        catch(IndexOutOfBoundsException aioobe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }
    }//GEN-LAST:event_useItemActionPerformed

    private void removeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeItemActionPerformed
        try
        {

            int[] a = itemSelection.getSelectedIndices();
            Integer[] arr = sortDesc(a);
            for (Integer arr1 : arr)
            {
                h.destroyItem(arr1);
            }

        }
        catch(NullPointerException | IndexOutOfBoundsException npe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }
        catch(NumberFormatException nfe)
        {
        }
        finally
        {
            showInvWep();
        }
    }//GEN-LAST:event_removeItemActionPerformed

    private void weaponSelectionValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_weaponSelectionValueChanged
        try
        {
            Weapon w = h.getWeaponObject(weaponSelection.getSelectedIndex());
            selectedWeapon.setText(w.getWeaponStats());
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {

        }
    }//GEN-LAST:event_weaponSelectionValueChanged

    private void closeInventoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeInventoryActionPerformed
        Inventory.this.dispose();
    }//GEN-LAST:event_closeInventoryActionPerformed

    private void clearSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearSelectionActionPerformed
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        selectedWeapon.setText("");
        selectedItem.setText("");
    }//GEN-LAST:event_clearSelectionActionPerformed

    private void switchWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_switchWeaponActionPerformed

        String message = h.switchWeapon(weaponSelection.getSelectedIndex());
        JOptionPane.showMessageDialog(null,message);
        showInvWep();
    }//GEN-LAST:event_switchWeaponActionPerformed

    private void sellWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sellWeaponActionPerformed

        try
        {
            int[] b = weaponSelection.getSelectedIndices();
            Integer[] arr2 = sortDesc(b);
            for (Integer arr21 : arr2)
            {
                Weapon w = h.getWeaponObject(arr21);
                String message = "Are you sure you want to sell your " + w.getName() + " for " + h.displayCurrency(w.getValue()) + ".";
                Object[] options = {"Yes","No"};
                int n = JOptionPane.showOptionDialog(null,message, "Sell weapon?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
                if (n==0) {
                    double newmoney = h.getMoney() + w.getValue();
                    h.setMoney(newmoney);
                    h.destroyWeapon(arr21);
                }
            }
        }
        catch(IndexOutOfBoundsException aioobe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }
        catch(NullPointerException npe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }
        catch(NumberFormatException nfe)
        {
        }
        showInvWep();

    }//GEN-LAST:event_sellWeaponActionPerformed

    private void repairWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repairWeaponActionPerformed

        Object[] options = {"Yes","No"};
        int n = JOptionPane.showOptionDialog(null,"Repairing your current weapon has a random chance of failing causing your weapon to lose health. Do you want to continue?", "Repair weapon?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
        if(n==0)
        {
            h.repairWeapon();
        }
        showInvWep();
    }//GEN-LAST:event_repairWeaponActionPerformed

    private void removeWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeWeaponActionPerformed
        try
        {

            int[] a = weaponSelection.getSelectedIndices();
            Integer[] arr = sortDesc(a);
            for (Integer arr1 : arr)
            {
                h.destroyWeapon(arr1);
            }
            showInvWep();
        }
        catch(NumberFormatException nfe)
        {
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {
            JOptionPane.showMessageDialog(null, "Please select an item.");
        }
    }//GEN-LAST:event_removeWeaponActionPerformed
    
    Hero h;
    private final DefaultListModel<String> weaponModel = new DefaultListModel<>();
    private final DefaultListModel<String> itemModel = new DefaultListModel<>();
  
    private final JList<String> weaponSelection;
    private final JList<String> itemSelection;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearSelection;
    private javax.swing.JButton clearSelection1;
    private javax.swing.JButton closeInventory;
    private javax.swing.JButton closeInventory1;
    private javax.swing.JTextArea currentWeapon;
    private javax.swing.JTextArea currentWeapon1;
    private javax.swing.JScrollPane currentWeaponScroll;
    private javax.swing.JScrollPane currentWeaponScroll1;
    private javax.swing.JPanel heroStatPanel1;
    private javax.swing.JScrollPane heroStatScroll;
    private javax.swing.JScrollPane heroStatScroll1;
    private javax.swing.JTextArea heroStats;
    private javax.swing.JTextArea heroStats1;
    private javax.swing.JPanel heroStatsPanel;
    private javax.swing.JLabel instrucItemLbl;
    private javax.swing.JLabel instrucWepLbl;
    private javax.swing.JTabbedPane inventoryTabs;
    private javax.swing.JPanel itemActionPanel;
    /*
    private javax.swing.JList itemSelection;
    */
    private javax.swing.JPanel itemSelectionPanel;
    private javax.swing.JScrollPane itemSelectionScroll;
    private javax.swing.JTextField itemSlot;
    private javax.swing.JPanel itemSlotPanel;
    private javax.swing.JPanel itemTabPanel;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JButton removeItem;
    private javax.swing.JButton removeWeapon;
    private javax.swing.JButton repairWeapon;
    private javax.swing.JTextArea selectedItem;
    private javax.swing.JPanel selectedItemPanel;
    private javax.swing.JScrollPane selectedItemScroll;
    private javax.swing.JTextArea selectedWeapon;
    private javax.swing.JScrollPane selectedWeaponScroll;
    private javax.swing.JButton sellItem;
    private javax.swing.JButton sellWeapon;
    private javax.swing.JButton switchWeapon;
    private javax.swing.JButton useItem;
    private javax.swing.JPanel weaponActionPanel;
    private javax.swing.JPanel weaponEquipedPanel;
    private javax.swing.JPanel weaponEquipedPanel1;
    private javax.swing.JPanel weaponSelectedPanel;
    /*
    private javax.swing.JList weaponSelection;
    */
    private javax.swing.JPanel weaponSelectionPanel;
    private javax.swing.JScrollPane weaponSelectionScroll;
    private javax.swing.JTextField weaponSlots;
    private javax.swing.JPanel weaponTabPanel;
    // End of variables declaration//GEN-END:variables
}
