package Enemies;

import Tools.RDN;
import java.io.Serializable;
import java.util.ArrayList;


public class Enemy implements Serializable
{
    private String enemyName;  
    private int enemyAttack;
    private int enemyHealth;
    
    private final ArrayList<EnemyConverter> enemies = new ArrayList<>();
    
    public Enemy(String name)
    {        
       Creeper cb = new Creeper();
       Demon da = new Demon();
       Dragon gs = new Dragon();
       EvilBunny ls = new EvilBunny();
       Ogre lb = new Ogre();
       Skeleton me = new Skeleton();
       Spider ml = new Spider();
       Wolf sb = new Wolf();
       Zombie st = new Zombie();
       
       enemies.add(cb);
       enemies.add(da);
       enemies.add(gs);
       enemies.add(ls);
       enemies.add(lb);
       enemies.add(me);
       enemies.add(ml);
       enemies.add(sb);
       enemies.add(st);
       
       for(EnemyConverter wc : enemies)
       {
           if(wc.getEnemyName().equals(name))
           {
               enemyName = wc.getEnemyName();
               enemyAttack = wc.getEnemyAttack();
               enemyHealth = wc.getEnemyHealth();
           }  
       }
       
       if (name.equals("Random"))
        {
            RDN rn = new RDN(enemies.size());
            int r = rn.RN();
            EnemyConverter wc = enemies.get(r);
            enemyName = wc.getEnemyName();
            enemyAttack = wc.getEnemyAttack();
            enemyHealth = wc.getEnemyHealth();
        }
       
    }

    /**
     * @return the enemyName
     */
    public String getEnemyName()
    {
        return enemyName;
    }

    /**
     * @param enemyName the enemyName to set
     */
    public void setEnemyName(String enemyName)
    {
        this.enemyName = enemyName;
    }

    /**
     * @return the enemyAttack
     */
    public int getEnemyAttack()
    {
        return enemyAttack;
    }

    /**
     * @param enemyAttack the enemyAttack to set
     */
    public void setEnemyAttack(int enemyAttack)
    {
        this.enemyAttack = enemyAttack;
    }

    /**
     * @return the enemyHealth
     */
    public int getEnemyHealth()
    {
        return enemyHealth;
    }


    public void setEnemyHealth(int enemyHealth)
    {
        this.enemyHealth = enemyHealth;
    }
    
    public String displayEnemy()
    {
        return("Enemy Name: " + getEnemyName() + "\n" + "Enemy Attack: " + getEnemyAttack() + "\n" + "Enemy Health: " + getEnemyHealth());
    }
}
