package Hero;

import java.io.Serializable;


public class Level implements Serializable 
{
    private int numberOfLevels = 50;
    //[x = Current Level][0 = Hero Attack, 1 = Hero Health]
    private int[][] levelArr = new int[numberOfLevels + 1][4];//10 Levels and 2 Variables
    //[x = Current Level][0 = Exp Requirement, 1 = Next Level]
    private int[][] exp = new int[numberOfLevels + 1][2];
    
    public Level()
    {
        for(int i = 0; i < levelArr.length; i++)
        {
            //Hero Attack
            levelArr[i][0] = (int)(2.5 * i) + 10;
            //Hero Health
            levelArr[i][1] = (int)(50.75 * i) + 200;
            //Weapon Slots
            levelArr[i][2] = 6 + i;
            //Item Slots
            levelArr[i][3] = 6 + (2 * i);
            
            //<editor-fold defaultstate="collapsed" desc="Exp Level Requirements">
            if(i > 1 && i < (levelArr.length/2))
            {
                exp[i][0] = exp[i - 1][0] + ((int)(1000 * (Math.log10(i))));
            }
            if(i>= (levelArr.length/2))
            {
                exp[i][0] = exp[i - 1][0] + ((int)(1000 * (Math.log10(i + 5))));
            }
            if(i == 0)
            {
                exp[i][0] = + ((int)(100 * (Math.log10(i + 1.5))));
            }
            if(i == 1)
            {
                exp[i][0] = + ((int)(100 * (Math.log10(i + 1.9))));
            }
             //</editor-fold>
            
            //Next Level
            exp[i][1] = i + 1;
        }
    }
    
    public int[] getCurrentLevelArray(int level)
    {
        return levelArr[level];
    }
    
    public int[] getExpRequirement(int level)
    {
        return exp[level];
    }
    public int getNumberOfLevels()
    {
        return numberOfLevels;
    }
    
}
