package Menus;

import Weapons.Weapon;
import Hero.*;
import Places.*;
import Items.Item;
import java.util.ArrayList;
import Tools.DisplayFormat;
import java.util.Arrays;
import java.util.Collections;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JOptionPane;

public class Store extends javax.swing.JFrame 
{
    Hero h;
    private final DefaultListModel<String> weaponModel = new DefaultListModel<>();
    private final DefaultListModel<String> itemModel = new DefaultListModel<>(); 
    private final JList<String> weaponSelection;
    private final JList<String> itemSelection;
    
    private final DefaultListModel<String> weaponModelSale = new DefaultListModel<>();
    private final DefaultListModel<String> itemModelSale = new DefaultListModel<>();
    private final JList<String> weaponSelectionSale;
    private final JList<String> itemSelectionSale;
    
    ArrayList<Weapon> wepSel = new ArrayList<>();
    ArrayList<Item> itmSel = new ArrayList<>();
    
    private double total;
    private double totalItem;
    DisplayFormat df = new DisplayFormat();
    
    public Store(Hero hero, String pn) 
    {  
        h = hero;
        
        weaponSelection = new JList<>();
        itemSelection = new JList<>();
        weaponSelectionSale = new JList<>();
        itemSelectionSale = new JList<>();
        
        weaponSelection.setModel(weaponModel);
        itemSelection.setModel(itemModel);       
        weaponSelectionSale.setModel(weaponModelSale);
        itemSelectionSale.setModel(itemModelSale);
           
        initComponents();
        Locations l = new Locations();
        ArrayList<LocationConverter> placelist = h.getLocationList();
        
        int storeItems;
        for(LocationConverter lc : placelist)
        {
            if(lc.getName().equals(pn))
            {
                storeItems = lc.getNumberOfStoreItems();
                h.stockWeaponStore(storeItems);
                h.stockItemStore(storeItems);
            }
            
        }
        
        showInvWep();
        moneyField.setText(df.formatCurrency(h.getHeroMoney()));
        moneyField1.setText(df.formatCurrency(h.getHeroMoney()));
       
    }
    
     public static boolean isInt(String s)
    {
         try
         {
             Integer.parseInt(s);
             return true;
         }
         catch(NumberFormatException nfe)
         {
             return false;
         }
    }
    
    public final void showInvWep()
    {        
          
        moneyField.setText(df.formatCurrency(h.getHeroMoney()));
        moneyField1.setText(df.formatCurrency(h.getHeroMoney()));
        weaponSlots.setText(h.getWeaponInventoryCounter() + "");
        itemSlot.setText(h.getItemInventoryCounter() + "");
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        weaponModel.clear();
        itemModel.clear();
        itemSelection.setModel(itemModel);
        weaponSelection.setModel(weaponModel);
        for(int i = 0; i < h.getWeaponInventory().size(); i++)
        {
           Weapon w = h.getWeaponInventory().get(i);     
           weaponModel.addElement(w.getWeaponName());
        }
        
        for(int z = 0; z <h.getItemInventory().size(); z++)
        {
            Item i = h.getItemInventory().get(z);
            itemModel.addElement(i.getItemName());
        }
        
        
        weaponSelectionSale.clearSelection();
        itemSelectionSale.clearSelection();
        weaponModelSale.clear();
        itemModelSale.clear();
        
        for(int i = 0; i < h.getStoreWeapons().size(); i++)
        {
           Weapon w = h.getStoreWeapons().get(i);     
           weaponModelSale.addElement(w.getWeaponName());
        }
        weaponSelectionSale.setModel(weaponModelSale);
        for(int z = 0; z < h.getStoreItem().size(); z++)
        {
            Item i = h.getStoreItem().get(z);
            itemModelSale.addElement(i.getItemName());
        }
        
       
        weaponSelectionSale.clearSelection();
        itemSelectionSale.clearSelection();
        selectedWeaponSale.setText("");
        selectedItemSale.setText("");
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        inventoryTabs = new javax.swing.JTabbedPane();
        weaponTabPanel = new javax.swing.JPanel();
        instrucWepLbl = new javax.swing.JLabel();
        weaponActionPanel = new javax.swing.JPanel();
        sellWeapon = new javax.swing.JButton();
        clearSelection = new javax.swing.JButton();
        exitShop = new javax.swing.JButton();
        buyAWeapon = new javax.swing.JButton();
        selectWeaponSalePanel = new javax.swing.JPanel();
        selectedWeaponScroll1 = new javax.swing.JScrollPane();
        selectedWeaponSale = new javax.swing.JTextArea();
        weaponSelectedPanel = new javax.swing.JPanel();
        selectedWeaponScroll = new javax.swing.JScrollPane();
        selectedWeapon = new javax.swing.JTextArea();
        weaponSelectionPanel = new javax.swing.JPanel();
        weaponSelectionScroll = new javax.swing.JScrollPane();
        /*
        weaponSelection = ;//new javax.swing.JList();
        */
        weaponSalePanel = new javax.swing.JPanel();
        weaponSelectionScrollSale = new javax.swing.JScrollPane();
        /*
        weaponSelectionSale = ;//new javax.swing.JList();
        */
        weaponSlotsFreePanel = new javax.swing.JPanel();
        weaponSlots = new javax.swing.JTextField();
        currentMoneyPanel = new javax.swing.JPanel();
        moneyField = new javax.swing.JTextField();
        totalWepSalePanel = new javax.swing.JPanel();
        totalWepSale = new javax.swing.JTextField();
        itemTabPanel = new javax.swing.JPanel();
        instrucItemLbl = new javax.swing.JLabel();
        itemActionPanel = new javax.swing.JPanel();
        clearSelection1 = new javax.swing.JButton();
        closeInventory1 = new javax.swing.JButton();
        sellItem = new javax.swing.JButton();
        BuyAnItem = new javax.swing.JButton();
        selectedItemPanel = new javax.swing.JPanel();
        selectedItemScroll = new javax.swing.JScrollPane();
        selectedItem = new javax.swing.JTextArea();
        heroStatPanel1 = new javax.swing.JPanel();
        itemSelectionScroll1 = new javax.swing.JScrollPane();
        /*
        itemSelectionSale = new javax.swing.JList();
        */
        weaponEquipedPanel1 = new javax.swing.JPanel();
        selectedItemScroll1 = new javax.swing.JScrollPane();
        selectedItemSale = new javax.swing.JTextArea();
        itemSelectionPanel = new javax.swing.JPanel();
        itemSelectionScroll = new javax.swing.JScrollPane();
        /*
        itemSelection = new javax.swing.JList();
        */
        itemSlotPanel = new javax.swing.JPanel();
        itemSlot = new javax.swing.JTextField();
        currentMoneyPanel1 = new javax.swing.JPanel();
        moneyField1 = new javax.swing.JTextField();
        totalItemSalePanel = new javax.swing.JPanel();
        totalItemSale = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Inventory - Legend of the Secret");
        setResizable(false);

        inventoryTabs.setBorder(javax.swing.BorderFactory.createTitledBorder("Store"));

        instrucWepLbl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        instrucWepLbl.setText("<html><center>Please select a weapon in the list and then select an action to perform. </center> </html>");
        instrucWepLbl.setAutoscrolls(true);
        instrucWepLbl.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instrucWepLbl.setMaximumSize(new java.awt.Dimension(201, 14));
        instrucWepLbl.setMinimumSize(new java.awt.Dimension(201, 14));
        instrucWepLbl.setPreferredSize(new java.awt.Dimension(201, 14));

        weaponActionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        sellWeapon.setText("Sell selected weapons");
        sellWeapon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sellWeaponActionPerformed(evt);
            }
        });

        clearSelection.setText("Clear Selections");
        clearSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearSelectionActionPerformed(evt);
            }
        });

        exitShop.setText("Exit the Shop");
        exitShop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitShopActionPerformed(evt);
            }
        });

        buyAWeapon.setText("Buy selected weapons");
        buyAWeapon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buyAWeaponActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout weaponActionPanelLayout = new javax.swing.GroupLayout(weaponActionPanel);
        weaponActionPanel.setLayout(weaponActionPanelLayout);
        weaponActionPanelLayout.setHorizontalGroup(
            weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(sellWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                    .addComponent(clearSelection, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(exitShop, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(buyAWeapon, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        weaponActionPanelLayout.setVerticalGroup(
            weaponActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(buyAWeapon)
                .addGap(5, 5, 5)
                .addComponent(sellWeapon)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(clearSelection)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(exitShop)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        selectWeaponSalePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Selected Weapon"));

        selectedWeaponSale.setEditable(false);
        selectedWeaponSale.setColumns(20);
        selectedWeaponSale.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedWeaponSale.setRows(5);
        selectedWeaponScroll1.setViewportView(selectedWeaponSale);

        javax.swing.GroupLayout selectWeaponSalePanelLayout = new javax.swing.GroupLayout(selectWeaponSalePanel);
        selectWeaponSalePanel.setLayout(selectWeaponSalePanelLayout);
        selectWeaponSalePanelLayout.setHorizontalGroup(
            selectWeaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 241, Short.MAX_VALUE)
            .addGroup(selectWeaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(selectWeaponSalePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        selectWeaponSalePanelLayout.setVerticalGroup(
            selectWeaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 140, Short.MAX_VALUE)
            .addGroup(selectWeaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(selectWeaponSalePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 118, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponSelectedPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Selected Weapon"));

        selectedWeapon.setEditable(false);
        selectedWeapon.setColumns(20);
        selectedWeapon.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedWeapon.setRows(5);
        selectedWeaponScroll.setViewportView(selectedWeapon);

        javax.swing.GroupLayout weaponSelectedPanelLayout = new javax.swing.GroupLayout(weaponSelectedPanel);
        weaponSelectedPanel.setLayout(weaponSelectedPanelLayout);
        weaponSelectedPanelLayout.setHorizontalGroup(
            weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 248, Short.MAX_VALUE)
            .addGroup(weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponSelectedPanelLayout.setVerticalGroup(
            weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 140, Short.MAX_VALUE)
            .addGroup(weaponSelectedPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectedPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedWeaponScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 118, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponSelectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapons in your Inventory"));

        weaponSelection.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                weaponSelectionValueChanged(evt);
            }
        });
        weaponSelectionScroll.setViewportView(weaponSelection);

        javax.swing.GroupLayout weaponSelectionPanelLayout = new javax.swing.GroupLayout(weaponSelectionPanel);
        weaponSelectionPanel.setLayout(weaponSelectionPanelLayout);
        weaponSelectionPanelLayout.setHorizontalGroup(
            weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 248, Short.MAX_VALUE)
            .addGroup(weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponSelectionPanelLayout.setVerticalGroup(
            weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 242, Short.MAX_VALUE)
            .addGroup(weaponSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScroll, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        weaponSalePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapons for Sale"));

        weaponSelectionSale.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                weaponSelectionSaleValueChanged(evt);
            }
        });
        weaponSelectionScrollSale.setViewportView(weaponSelectionSale);

        javax.swing.GroupLayout weaponSalePanelLayout = new javax.swing.GroupLayout(weaponSalePanel);
        weaponSalePanel.setLayout(weaponSalePanelLayout);
        weaponSalePanelLayout.setHorizontalGroup(
            weaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 241, Short.MAX_VALUE)
            .addGroup(weaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSalePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScrollSale, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        weaponSalePanelLayout.setVerticalGroup(
            weaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(weaponSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSalePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSelectionScrollSale, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponSlotsFreePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Weapon Slots Free"));

        weaponSlots.setEditable(false);

        javax.swing.GroupLayout weaponSlotsFreePanelLayout = new javax.swing.GroupLayout(weaponSlotsFreePanel);
        weaponSlotsFreePanel.setLayout(weaponSlotsFreePanelLayout);
        weaponSlotsFreePanelLayout.setHorizontalGroup(
            weaponSlotsFreePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 132, Short.MAX_VALUE)
            .addGroup(weaponSlotsFreePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSlotsFreePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSlots, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );
        weaponSlotsFreePanelLayout.setVerticalGroup(
            weaponSlotsFreePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 52, Short.MAX_VALUE)
            .addGroup(weaponSlotsFreePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(weaponSlotsFreePanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(weaponSlots, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );

        currentMoneyPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Current Money"));

        moneyField.setEditable(false);

        javax.swing.GroupLayout currentMoneyPanelLayout = new javax.swing.GroupLayout(currentMoneyPanel);
        currentMoneyPanel.setLayout(currentMoneyPanelLayout);
        currentMoneyPanelLayout.setHorizontalGroup(
            currentMoneyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(currentMoneyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(moneyField, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        currentMoneyPanelLayout.setVerticalGroup(
            currentMoneyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(currentMoneyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(moneyField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        totalWepSalePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Total of Items Selected"));

        totalWepSale.setEditable(false);

        javax.swing.GroupLayout totalWepSalePanelLayout = new javax.swing.GroupLayout(totalWepSalePanel);
        totalWepSalePanel.setLayout(totalWepSalePanelLayout);
        totalWepSalePanelLayout.setHorizontalGroup(
            totalWepSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(totalWepSalePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(totalWepSale, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        totalWepSalePanelLayout.setVerticalGroup(
            totalWepSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(totalWepSalePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(totalWepSale, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout weaponTabPanelLayout = new javax.swing.GroupLayout(weaponTabPanel);
        weaponTabPanel.setLayout(weaponTabPanelLayout);
        weaponTabPanelLayout.setHorizontalGroup(
            weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(weaponTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(weaponSelectedPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(weaponSelectionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(selectWeaponSalePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(weaponSalePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(weaponTabPanelLayout.createSequentialGroup()
                                .addGap(33, 33, 33)
                                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(currentMoneyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(weaponSlotsFreePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(totalWepSalePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(weaponTabPanelLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(instrucWepLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, weaponTabPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(weaponActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        weaponTabPanelLayout.setVerticalGroup(
            weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, weaponTabPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(weaponTabPanelLayout.createSequentialGroup()
                                .addComponent(weaponActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(currentMoneyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(weaponSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(weaponSalePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(weaponTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(weaponSelectedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(selectWeaponSalePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(weaponTabPanelLayout.createSequentialGroup()
                        .addComponent(totalWepSalePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(weaponSlotsFreePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(instrucWepLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(26, 26, 26))
        );

        inventoryTabs.addTab("Weapons", weaponTabPanel);

        instrucItemLbl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        instrucItemLbl.setText("<html><center>Please select a item in the list and then select an action to perform. </center> </html>");
        instrucItemLbl.setAutoscrolls(true);
        instrucItemLbl.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        instrucItemLbl.setMaximumSize(new java.awt.Dimension(201, 14));
        instrucItemLbl.setMinimumSize(new java.awt.Dimension(201, 14));
        instrucItemLbl.setPreferredSize(new java.awt.Dimension(201, 14));

        itemActionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));
        itemActionPanel.setPreferredSize(new java.awt.Dimension(199, 213));

        clearSelection1.setText("Clear Selections");
        clearSelection1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearSelection1ActionPerformed(evt);
            }
        });

        closeInventory1.setText("Exit the Shop");
        closeInventory1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeInventory1ActionPerformed(evt);
            }
        });

        sellItem.setText("Sell selected items");
        sellItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sellItemActionPerformed(evt);
            }
        });

        BuyAnItem.setText("Buy selected items");
        BuyAnItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BuyAnItemActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout itemActionPanelLayout = new javax.swing.GroupLayout(itemActionPanel);
        itemActionPanel.setLayout(itemActionPanelLayout);
        itemActionPanelLayout.setHorizontalGroup(
            itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(closeInventory1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(clearSelection1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(sellItem, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                    .addComponent(BuyAnItem, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        itemActionPanelLayout.setVerticalGroup(
            itemActionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemActionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BuyAnItem)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sellItem)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(clearSelection1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(closeInventory1)
                .addContainerGap())
        );

        selectedItemPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Selected Item"));
        selectedItemPanel.setPreferredSize(new java.awt.Dimension(260, 150));

        selectedItem.setEditable(false);
        selectedItem.setColumns(20);
        selectedItem.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedItem.setRows(5);
        selectedItemScroll.setViewportView(selectedItem);

        javax.swing.GroupLayout selectedItemPanelLayout = new javax.swing.GroupLayout(selectedItemPanel);
        selectedItemPanel.setLayout(selectedItemPanelLayout);
        selectedItemPanelLayout.setHorizontalGroup(
            selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 248, Short.MAX_VALUE)
            .addGroup(selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(selectedItemPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedItemScroll)
                    .addContainerGap()))
        );
        selectedItemPanelLayout.setVerticalGroup(
            selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 140, Short.MAX_VALUE)
            .addGroup(selectedItemPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(selectedItemPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(selectedItemScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 118, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        heroStatPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Items for Sale"));
        heroStatPanel1.setPreferredSize(new java.awt.Dimension(222, 229));

        itemSelectionSale.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                itemSelectionSaleValueChanged(evt);
            }
        });
        itemSelectionScroll1.setViewportView(itemSelectionSale);

        javax.swing.GroupLayout heroStatPanel1Layout = new javax.swing.GroupLayout(heroStatPanel1);
        heroStatPanel1.setLayout(heroStatPanel1Layout);
        heroStatPanel1Layout.setHorizontalGroup(
            heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 241, Short.MAX_VALUE)
            .addGroup(heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        heroStatPanel1Layout.setVerticalGroup(
            heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 242, Short.MAX_VALUE)
            .addGroup(heroStatPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(heroStatPanel1Layout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        weaponEquipedPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Information for Selected Item"));
        weaponEquipedPanel1.setPreferredSize(new java.awt.Dimension(250, 150));

        selectedItemSale.setEditable(false);
        selectedItemSale.setColumns(20);
        selectedItemSale.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        selectedItemSale.setRows(5);
        selectedItemScroll1.setViewportView(selectedItemSale);

        javax.swing.GroupLayout weaponEquipedPanel1Layout = new javax.swing.GroupLayout(weaponEquipedPanel1);
        weaponEquipedPanel1.setLayout(weaponEquipedPanel1Layout);
        weaponEquipedPanel1Layout.setHorizontalGroup(
            weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponEquipedPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectedItemScroll1, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                .addContainerGap())
        );
        weaponEquipedPanel1Layout.setVerticalGroup(
            weaponEquipedPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(weaponEquipedPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectedItemScroll1)
                .addContainerGap())
        );

        itemSelectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Item Selection"));
        itemSelectionPanel.setPreferredSize(new java.awt.Dimension(301, 229));

        itemSelection.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                itemSelectionValueChanged(evt);
            }
        });
        itemSelectionScroll.setViewportView(itemSelection);

        javax.swing.GroupLayout itemSelectionPanelLayout = new javax.swing.GroupLayout(itemSelectionPanel);
        itemSelectionPanel.setLayout(itemSelectionPanelLayout);
        itemSelectionPanelLayout.setHorizontalGroup(
            itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 248, Short.MAX_VALUE)
            .addGroup(itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(itemSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE)
                    .addContainerGap()))
        );
        itemSelectionPanelLayout.setVerticalGroup(
            itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 242, Short.MAX_VALUE)
            .addGroup(itemSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(itemSelectionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(itemSelectionScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        itemSlotPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Item Slots Free"));
        itemSlotPanel.setPreferredSize(new java.awt.Dimension(144, 75));

        itemSlot.setEditable(false);

        javax.swing.GroupLayout itemSlotPanelLayout = new javax.swing.GroupLayout(itemSlotPanel);
        itemSlotPanel.setLayout(itemSlotPanelLayout);
        itemSlotPanelLayout.setHorizontalGroup(
            itemSlotPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemSlotPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(itemSlot, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
                .addContainerGap())
        );
        itemSlotPanelLayout.setVerticalGroup(
            itemSlotPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemSlotPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(itemSlot, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
                .addContainerGap())
        );

        currentMoneyPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Current Money"));

        moneyField1.setEditable(false);

        javax.swing.GroupLayout currentMoneyPanel1Layout = new javax.swing.GroupLayout(currentMoneyPanel1);
        currentMoneyPanel1.setLayout(currentMoneyPanel1Layout);
        currentMoneyPanel1Layout.setHorizontalGroup(
            currentMoneyPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(currentMoneyPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(moneyField1, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        currentMoneyPanel1Layout.setVerticalGroup(
            currentMoneyPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(currentMoneyPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(moneyField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        totalItemSalePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Total of Items Selected"));

        totalItemSale.setEditable(false);

        javax.swing.GroupLayout totalItemSalePanelLayout = new javax.swing.GroupLayout(totalItemSalePanel);
        totalItemSalePanel.setLayout(totalItemSalePanelLayout);
        totalItemSalePanelLayout.setHorizontalGroup(
            totalItemSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(totalItemSalePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(totalItemSale, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        totalItemSalePanelLayout.setVerticalGroup(
            totalItemSalePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(totalItemSalePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(totalItemSale, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout itemTabPanelLayout = new javax.swing.GroupLayout(itemTabPanel);
        itemTabPanel.setLayout(itemTabPanelLayout);
        itemTabPanelLayout.setHorizontalGroup(
            itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(itemSelectionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 260, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(selectedItemPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(heroStatPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE)
                    .addComponent(weaponEquipedPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE))
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(itemActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addGap(33, 33, 33)
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(itemSlotPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(currentMoneyPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(totalItemSalePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(instrucItemLbl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        itemTabPanelLayout.setVerticalGroup(
            itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(itemTabPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addComponent(itemActionPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(currentMoneyPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(totalItemSalePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                        .addComponent(itemSlotPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(instrucItemLbl, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(itemTabPanelLayout.createSequentialGroup()
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(itemSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE)
                            .addComponent(heroStatPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(itemTabPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(selectedItemPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                            .addComponent(weaponEquipedPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        inventoryTabs.addTab("Items", itemTabPanel);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(inventoryTabs)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(inventoryTabs, javax.swing.GroupLayout.PREFERRED_SIZE, 503, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public Integer[] sortDesc(int[] aryNums)
    {
           
           Integer[] integerArray = new Integer[aryNums.length];
            
           for(int i = 0; i<aryNums.length; i++)
           {
               integerArray[i] = new Integer(aryNums[i]);
           }
           Arrays.sort(integerArray, Collections.reverseOrder());
        return integerArray;
    }
    
    private void itemSelectionValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_itemSelectionValueChanged
        try
        {
            Item i = h.getStoreItem().get(itemSelection.getSelectedIndex());
            selectedItem.setText(i.displayStoreItems());
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {
            JOptionPane.showMessageDialog(null,aioobe);
        }
    }//GEN-LAST:event_itemSelectionValueChanged

    private void sellItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sellItemActionPerformed

//        //int remitem = itemSelection.getSelectedIndex();
//        try
//        {
//            int[] a = itemSelection.getSelectedIndices();
//            Integer[] arr = sortDesc(a);
//            for (Integer arr1 : arr)
//            {
//                int remitem = arr1;
//                Item i = h.getItemObject(remitem);
//                String message = "Are you sure you want to sell your " + i.getName() + " for " + h.displayCurrency(i.getValue()) + ".";
//                Object[] options = {"Yes","No"};
//                int n = JOptionPane.showOptionDialog(null,message, "Sell item?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
//                if(n==0)
//                {
//                    double newmoney = h.getMoney() + i.getValue();
//                    h.setMoney(newmoney);
//                    h.destroyItem(remitem);
//                }
//            }
//        }
//        catch(IndexOutOfBoundsException aioobe)
//        {
//            JOptionPane.showMessageDialog(null, "Please select an item.");
//        }
//
//        showInvWep();

    }//GEN-LAST:event_sellItemActionPerformed

    private void closeInventory1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeInventory1ActionPerformed
        Store.this.dispose();
    }//GEN-LAST:event_closeInventory1ActionPerformed

    private void clearSelection1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearSelection1ActionPerformed
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        selectedWeapon.setText("");
        selectedItem.setText("");
        weaponSelectionSale.clearSelection();
        itemSelectionSale.clearSelection();
        selectedWeaponSale.setText("");
        selectedItemSale.setText("");
        totalWepSale.setText("");
        totalItemSale.setText("");
    }//GEN-LAST:event_clearSelection1ActionPerformed

    private void weaponSelectionValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_weaponSelectionValueChanged
        try
        {
            Weapon w = h.getStoreWeapons().get(weaponSelection.getSelectedIndex());
            selectedWeapon.setText(w.toString());
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {

        }
    }//GEN-LAST:event_weaponSelectionValueChanged

    private void exitShopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitShopActionPerformed
        Store.this.dispose();
    }//GEN-LAST:event_exitShopActionPerformed

    private void clearSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearSelectionActionPerformed
        weaponSelection.clearSelection();
        itemSelection.clearSelection();
        selectedWeapon.setText("");
        selectedItem.setText("");
        weaponSelectionSale.clearSelection();
        itemSelectionSale.clearSelection();
        selectedWeaponSale.setText("");
        selectedItemSale.setText("");
        totalWepSale.setText("");
        totalItemSale.setText("");
    }//GEN-LAST:event_clearSelectionActionPerformed

    private void sellWeaponActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sellWeaponActionPerformed
//
//        try
//        {
//            int[] b = weaponSelection.getSelectedIndices();
//            Integer[] arr2 = sortDesc(b);
//            for (Integer arr21 : arr2)
//            {
//                Weapon w = h.getWeaponObject(arr21);
//                String message = "Are you sure you want to sell your " + w.getName() + " for " + h.displayCurrency(w.getValue()) + ".";
//                Object[] options = {"Yes","No"};
//                int n = JOptionPane.showOptionDialog(null,message, "Sell weapon?", JOptionPane.YES_NO_OPTION, JOptionPane.DEFAULT_OPTION, null, options, options[1]);
//                if (n==0) {
//                    double newmoney = h.getMoney() + w.getValue();
//                    h.setMoney(newmoney);
//                    h.destroyWeapon(arr21);
//                }
//            }
//        }
//        catch(IndexOutOfBoundsException aioobe)
//        {
//            JOptionPane.showMessageDialog(null, "Please select an item.");
//        }
//        catch(NullPointerException npe)
//        {
//            JOptionPane.showMessageDialog(null, "Please select an item.");
//        }
//        catch(NumberFormatException nfe)
//        {
//        }
//        showInvWep();

    }//GEN-LAST:event_sellWeaponActionPerformed

    private void weaponSelectionSaleValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_weaponSelectionSaleValueChanged
    {//GEN-HEADEREND:event_weaponSelectionSaleValueChanged
        try
        {
            Weapon w = h.getStoreWeapons().get(weaponSelectionSale.getSelectedIndex());
            selectedWeaponSale.setText(w.toString());
            int[] a = weaponSelectionSale.getSelectedIndices();
            Integer[] arr = sortDesc(a);
            wepSel.clear();
            total = 0;
            for (Integer arr1 : arr)
            {
                Weapon ws = h.getStoreWeapons().get(arr1);
                wepSel.add(ws);
            }
            for(Weapon wst : wepSel)
            {
                total = total + wst.getWeaponValue();
            }
            totalWepSale.setText(df.formatCurrency(total));
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {

        }
    }//GEN-LAST:event_weaponSelectionSaleValueChanged

    private void buyAWeaponActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_buyAWeaponActionPerformed
    {//GEN-HEADEREND:event_buyAWeaponActionPerformed
//        try
//        {
//            int[] a = weaponSelectionSale.getSelectedIndices();
//            Integer[] arr = sortDesc(a);
//            String message = "";
//            for (Integer arr1 : arr)
//            {
//                message += h.buyWeapon(arr1) + "\n";
//                moneyField.setText(h.displayCurrency(h.getMoney()));
//            }
//            JOptionPane.showMessageDialog(null, message);
//            showInvWep();
//        }
//        catch(NumberFormatException nfe)
//        {
//        }
//        catch(ArrayIndexOutOfBoundsException aioobe)
//        {
//
//        }
    }//GEN-LAST:event_buyAWeaponActionPerformed

    private void BuyAnItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_BuyAnItemActionPerformed
    {//GEN-HEADEREND:event_BuyAnItemActionPerformed
//        try
//        {
//            int[] a = itemSelectionSale.getSelectedIndices();
//            Integer[] arr = sortDesc(a);
//            String message = "";
//            for (Integer arr1 : arr)
//            {
//                //int wepsele = itemSelection.getSelectedIndex();
//                message += h.buyItem(arr1) + "\n";
//                moneyField1.setText(h.displayCurrency(h.getMoney()));
//            }
//            JOptionPane.showMessageDialog(null, message);
//            showInvWep();
//        }
//        catch(NumberFormatException nfe)
//        {
//        }
//        catch(ArrayIndexOutOfBoundsException aioobe)
//        {
//
//        }
    }//GEN-LAST:event_BuyAnItemActionPerformed

    private void itemSelectionSaleValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_itemSelectionSaleValueChanged
    {//GEN-HEADEREND:event_itemSelectionSaleValueChanged
        try
        {
            Item i = h.getStoreItem().get(itemSelectionSale.getSelectedIndex());
            selectedItemSale.setText(i.displayStoreItems());
            int[] a = itemSelectionSale.getSelectedIndices();
            Integer[] arr = sortDesc(a);
            itmSel.clear();
            totalItem = 0;
            for (Integer arr1 : arr)
            {
                Item ws = h.getStoreItem().get(arr1);
                itmSel.add(ws);
            }
            for(Item wst : itmSel)
            {
                totalItem = totalItem + wst.getItemValue();//Price();
            }
            totalItemSale.setText(df.formatCurrency(totalItem));
        }
        catch(ArrayIndexOutOfBoundsException aioobe)
        {

        }
    }//GEN-LAST:event_itemSelectionSaleValueChanged
    
   
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BuyAnItem;
    private javax.swing.JButton buyAWeapon;
    private javax.swing.JButton clearSelection;
    private javax.swing.JButton clearSelection1;
    private javax.swing.JButton closeInventory1;
    private javax.swing.JPanel currentMoneyPanel;
    private javax.swing.JPanel currentMoneyPanel1;
    private javax.swing.JButton exitShop;
    private javax.swing.JPanel heroStatPanel1;
    private javax.swing.JLabel instrucItemLbl;
    private javax.swing.JLabel instrucWepLbl;
    private javax.swing.JTabbedPane inventoryTabs;
    private javax.swing.JPanel itemActionPanel;
    /*
    private javax.swing.JList itemSelection;
    */
    private javax.swing.JPanel itemSelectionPanel;
    /*
    private javax.swing.JList itemSelectionSale;
    */
    private javax.swing.JScrollPane itemSelectionScroll;
    private javax.swing.JScrollPane itemSelectionScroll1;
    private javax.swing.JTextField itemSlot;
    private javax.swing.JPanel itemSlotPanel;
    private javax.swing.JPanel itemTabPanel;
    private javax.swing.JTextField moneyField;
    private javax.swing.JTextField moneyField1;
    private javax.swing.JPanel selectWeaponSalePanel;
    private javax.swing.JTextArea selectedItem;
    private javax.swing.JPanel selectedItemPanel;
    private javax.swing.JTextArea selectedItemSale;
    private javax.swing.JScrollPane selectedItemScroll;
    private javax.swing.JScrollPane selectedItemScroll1;
    private javax.swing.JTextArea selectedWeapon;
    private javax.swing.JTextArea selectedWeaponSale;
    private javax.swing.JScrollPane selectedWeaponScroll;
    private javax.swing.JScrollPane selectedWeaponScroll1;
    private javax.swing.JButton sellItem;
    private javax.swing.JButton sellWeapon;
    private javax.swing.JTextField totalItemSale;
    private javax.swing.JPanel totalItemSalePanel;
    private javax.swing.JTextField totalWepSale;
    private javax.swing.JPanel totalWepSalePanel;
    private javax.swing.JPanel weaponActionPanel;
    private javax.swing.JPanel weaponEquipedPanel1;
    private javax.swing.JPanel weaponSalePanel;
    private javax.swing.JPanel weaponSelectedPanel;
    /*
    private javax.swing.JList weaponSelection;
    */
    private javax.swing.JPanel weaponSelectionPanel;
    /*
    private javax.swing.JList weaponSelectionSale;
    */
    private javax.swing.JScrollPane weaponSelectionScroll;
    private javax.swing.JScrollPane weaponSelectionScrollSale;
    private javax.swing.JTextField weaponSlots;
    private javax.swing.JPanel weaponSlotsFreePanel;
    private javax.swing.JPanel weaponTabPanel;
    // End of variables declaration//GEN-END:variables
}
