package Weapons;

import Tools.RDN;
import Tools.DisplayFormat;
import java.io.Serializable;
import java.util.ArrayList;

public class Weapon implements Serializable
{
    private String weaponName;  
    private int weaponAttack;
    private int weaponHealth;
    private double weaponValue;
    
    private final ArrayList<WeaponConverter> weapons = new ArrayList<>();
    
    public Weapon(String name, int attack, int health, double value)
    {
        weaponName = name;
        weaponAttack = attack;
        weaponHealth = health;
        weaponValue = value;
    }
    
    public Weapon(String name)
    {        
       Battleaxe ba = new Battleaxe();
       Crossbow cb = new Crossbow();
       Dagger da = new Dagger();
       GreatSword gs = new GreatSword();
       LongSword ls = new LongSword();
       Longbow lb = new Longbow();
       Mace me = new Mace();
       Maul ml = new Maul();
       Shortbow sb = new Shortbow();
       Staff st = new Staff();
       Sword sw = new Sword();
       Waraxe wa = new Waraxe();
       
       weapons.add(ba);
       weapons.add(cb); 
       weapons.add(da);
       weapons.add(gs);
       weapons.add(ls);
       weapons.add(lb);
       weapons.add(me);
       weapons.add(ml);
       weapons.add(sb);
       weapons.add(st);
       weapons.add(sw);
       weapons.add(wa);      
       
       for(WeaponConverter wc : weapons)
       {
           if(wc.getWeaponName().equals(name))
           {
               weaponName = wc.getWeaponName();
               weaponAttack = wc.getWeaponAttack();
               weaponHealth = wc.getWeaponHealth();
               weaponValue = wc.getWeaponValue();
           }  
       }
       
       if (name.equals("Random"))
        {
            RDN rn = new RDN(weapons.size());
            int r = rn.RN();
            WeaponConverter wc = weapons.get(r);
            weaponName = wc.getWeaponName();
            weaponAttack = wc.getWeaponAttack();
            weaponHealth = wc.getWeaponHealth();
            weaponValue = wc.getWeaponValue();
        }
       
    }

    /**
     * @return the weaponName
     */
    public String getWeaponName()
    {
        return weaponName;
    }

    /**
     * @param weaponName the weaponName to set
     */
    public void setWeaponName(String weaponName)
    {
        this.weaponName = weaponName;
    }

    /**
     * @return the weaponAttack
     */
    public int getWeaponAttack()
    {
        return weaponAttack;
    }

    /**
     * @param weaponAttack the weaponAttack to set
     */
    public void setWeaponAttack(int weaponAttack)
    {
        this.weaponAttack = weaponAttack;
    }

    /**
     * @return the weaponHealth
     */
    public int getWeaponHealth()
    {
        return weaponHealth;
    }

    /**
     * @param weaponHealth the weaponHealth to set
     */
    public void setWeaponHealth(int weaponHealth)
    {
        this.weaponHealth = weaponHealth;
    }

    /**
     * @return the weaponValue
     */
    public double getWeaponValue()
    {
        return weaponValue;
    }

    /**
     * @param weaponValue the weaponValue to set
     */
    public void setWeaponValue(double weaponValue)
    {
        this.weaponValue = weaponValue;
    }
    public String toString()
    {
        DisplayFormat df = new DisplayFormat();
        return("Weapon Name: " + getWeaponName() + "\n" + "Weapon Attack: " + getWeaponAttack() + "\n" + "Weapon Health: " + getWeaponHealth() + "\n" + "Value: " + df.formatCurrency(weaponValue));
    }
    
    public String repairWeapon(int level)
    {
        RDN rnchance = new RDN(11); //repair chance
	RDN rnrepair1 = new RDN(7); // repair multiplier 1
	RDN rnrepair2 = new RDN(5); // repair multiplier 2
        
        int rc = rnchance.RN();
        int rm1 = rnrepair1.RN();
        int rm2 = rnrepair2.RN();
        String finalmessage;

        int finalstat;
        if (rm1 == 0)
            rm1 = 1;
        if (rm2 == 0)
            rm2 = 2;

        if (rc % 2 == 0)
        {		
            finalstat = weaponHealth + (rm1 * rm2 + level);
            finalmessage = "Repair Successful, Weapon Health now at: " + finalstat;
        }
        else
        {	
            finalstat = weaponHealth - (rm1 * rm2);
            finalmessage = "Repair Unsuccessful, Weapon Health now at: " + finalstat;

            if (finalstat <= 0)
            {
                if (level < 3)
                {
                    finalmessage += "\n" + "You broke your weapon";
                }
                if (level < 3 && level < 10)
                {
                    finalstat = 10;
                    finalmessage += "\n" + "Your weapon broke, but with your advanced skills you were able to bring it back to life.\nWeapon Health: " + finalstat; 
                }
                if (level < 11 && level < 17)
                {
                    finalstat = 30;
                    finalmessage += "\n" + "Your weapon broke, but with your advanced skills you were able to bring it back to life.\nWeapon Health: " + finalstat; 
                }
            }
        }
        weaponHealth = finalstat;
        return finalmessage;
    }
}
