import java.io.Serializable;
import java.util.*;
import java.text.*;

public class Hero implements Serializable
{
	private String name; //default values
	private int health; // 300
	private int attack; // 10
	private int defense; // 10
	private int exp; // 0 
	private String status; //Normal (Poison,Burn,Paralyze,Sleeping,Confusion)
	private double money; //$0.00
	Weapon w1 = new Weapon();
	private DecimalFormat Currency = new DecimalFormat("$0.00");
	
	
	private String weaponName; //Weapon Name
	private int weaponAttack; //Weapon Attack Stats
	private int weaponStat; //Weapon Health
	private int weaponSpeed; //Weapon Speed
	private int inventorySizeA = 6; //6 weapons
	private String inventoryA[] = new String[inventorySizeA]; //Weapon Inventory
	private int inventorySizeB = 15; //15 items
	private String inventoryB[] = new String[inventorySizeB];  //Item Inventory	
	private int totalatk;
	
	public Hero()
	{
		setName("");
		setHealth(300);
		doWeapon();
		setDefense(10);
		setExp(0);
		totalatk = 10 + weaponAttack;
		setAttack(10);
		setStatus("Normal");
		setMoney(0.00);
		setAttackWeapon(totalatk);
		addWeaponToInv(weaponToString(w1));
	}
	
	public void addWeaponToInv(String ws1)
	{
		for(int i = 0; i<inventoryA.length; i++)
		{
			if(inventoryA[i] == null)
			{
				inventoryA[i] = ws1;
				i = inventoryA.length;
			}
		}
	}
	
	public void addItemToInv(String it1)
	{
		for(int i = 0; i<inventoryB.length; i++)
		{
			if(inventoryB[i] == null)
			{
				inventoryB[i] = it1;
				i = inventoryB.length;
			}
		}
	}
	
	
	
	public String weaponToString(Weapon wts)
	{
		String wName = wts.getName();
		String wAtk = Integer.toString(wts.getAtk());
		String wStat = Integer.toString(wts.getStat());
		String wSpeed = Integer.toString(wts.getSpeed());
		return(wName + "-" + wAtk + "-" + wStat + "-" + wSpeed);
	}
	
	public void weaponFromString(String wfs)
	{
		String[] str_array = wfs.split("-");
		weaponName = str_array[0];
		weaponAttack = Integer.parseInt(str_array[1]);
		weaponStat = Integer.parseInt(str_array[2]);
		weaponSpeed = Integer.parseInt(str_array[3]);
		w1.setName(weaponName);
		w1.setAtk(weaponAttack);
		w1.setStat(weaponStat);
		w1.setSpeed(weaponSpeed);
	}		
	
	public Weapon getWeaponObject()
	{
		return w1;
	}
	
	public void switchWeapon(int i)
	{
		String switch1;
		String switch2;
		
		switch1 = inventoryA[0];
		
		if (getInvSizeA() > i)
		{
			if (inventoryA[i] == null)
			{
				System.out.println("Switch not successful.");
			}
			else
			{
				switch2 = inventoryA[i];
				inventoryA[0] = switch2;
				inventoryA[i] = switch1;
				
				weaponFromString(switch2);
				
				System.out.println("The weapons have been successfully switched.\n");
				displaySingleInv(0);
				
			}
		}
	}
	
	public void destroyWeapon(int i)
	{
		if (getInvSizeA() > i)
		{
			if (inventoryA[i] == null)
			{
				System.out.println("Destroy not successful.");
			}
			else
			{
				if(i == 0)
				{
					System.out.println("You cannot do that.");
					System.out.println("Nothing removed.");
				}
				else
				{
					String dWeapon = inventoryA[i];
					inventoryA[i] = null;
					
				}
			}
		}
	}

	public void destroyItem(int i)
	{
		if (getInvSizeB() > i)
		{
			if (inventoryB[i] == null)
			{
				System.out.println("Destroy not successful.");
			}
			else
			{
				if (i == 0)
				{
					System.out.println("You cannot do that.");
					System.out.println("Nothing removed.");
				}
				else
				{
					String dItem = inventoryB[i];
					inventoryB[i] = null;
				}
			}
		}
	}
		
	public void removeWeapon(String rw)
	{
		for(int i = 0; i<inventoryA.length; i++)
		{
			if(inventoryA[i].equals(rw))
			{
				inventoryA[i] = null;
				i = inventoryA.length;
			}
		}
	}
	
	public void removeItem(String it)
	{
		
		for(int i = 0; i<inventoryB.length; i++)
		{
			if(inventoryB[i].equals(it))
			{
				i++;
				inventoryB[i] = null;
				i = inventoryB.length;
			}
		}
	}
	
	public void doWeapon()
	{
		weaponName = w1.getName();
		weaponAttack = w1.getAtk();
		weaponStat = w1.getStat();
		weaponSpeed = w1.getSpeed();
	}
	
	public String getWeaponStats()
	{
		String ws = w1.getWeaponStats();
		return ws;
	}
	
	public void repairWeapon()
	{
		weaponStat = (w1.getStat());
		w1.repairWeapon(weaponStat);
		weaponStat = (w1.getStat());		
	}
	
	public void setName(String n)
	{
		name = n;
	}
	
	public void setHealth(int h)
	{
		health = h;
	}
	
	public void setAttack(int a)
	{
		attack = a;
	}
	
	public void setAttackWeapon(int aw)
	{
		totalatk = aw;
	}
	
	public void setDefense(int d)
	{
		defense = d;
	}
	
	public void setExp(int e)
	{
		exp = e;
	}
	
	public void setWeaponName(String w)
	{
		weaponName = w;
	}
	
	
	public void setWeaponStat(int ws2)
	{
		w1.setStat(ws2);
	}
	
	public void setWeaponAttack(int watk2)
	{
		w1.setAtk(watk2);
	}
	
	public void setWeaponSpeed(int wspeed2)
	{
		w1.setSpeed(wspeed2);
	}
	
	public void setMoney(double m)
	{
		money = m;
	}
	
	public double getMoney()
	{
		return money;
	}
	
	public void setInvSizeA(int a)
	{
		inventorySizeA = a;
	}
	public void setInvSizeB(int b)
	{
		inventorySizeB = b;
	}
	public int getInvSizeA()
	{
		return inventorySizeA;
	}
	public int getInvSizeB()
	{
		return inventorySizeB;
	}
	
	public void setStatus(String s)
	{
		status = s;
	}
	
	public String getStatus()
	{
		return status;
	}
	
	public String getCurrency()
	{
		return (Currency.format(money));
	}
	
	public String getName()
	{
		return name;
	}
	
	public int getHealth()
	{
		return health;
	}
	
	public int getAttack()
	{
		return attack;
	}
	
	public int getAttackWeapon()
	{
		return totalatk;
	}
	
	public int getDefense()
	{
		return defense;
	}
	
	public int getExp()
	{
		return exp;
	}
	
	public String getWeaponName()
	{
		
		return weaponName;
	}
	
	public String getItem(int i)
	{
		String ic = "N#N#N";
		if (getInvSizeB() > i)
		{
			if (inventoryB[i] == null)
			{
				System.out.println("Item usage not successful.");
			}
			else
			{
				int a = i;
				String gi0;
				
				String[] str_array;
				int b = a - 1;
				//System.out.println(a);
				//System.out.println(b);
				//System.out.println(i);
				
				gi0 = inventoryB[b];
				str_array = gi0.split("_");
				ic = str_array[2];
				
			}
		}
		return ic;
	}
	
	public void getRawInv()
	{
		for(int i = 0; i<inventoryB.length; i++)
		{
			System.out.println(inventoryB[i]);
		}
	}
	
	public void getInventory()
	{
		String gi1;
		String gi2;
		String gi3;
		String gi0;
		String[] str_array;
		displaySingleInv(0);
		
		System.out.println("--Item Slot-----Weapon Name-------------Attack----Health----Speed----");
		for(int i = 1; i<inventoryA.length; i++)
		{
			if(inventoryA[i] != null)
			{
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
				System.out.println("       " + i + "        " + str_array[0] + "       " + str_array[1] + "        " + str_array[2] + "        " + str_array[3]);
			}
			else
			{
				System.out.println("No Weapon");
			}
		}
		/*for(int i = 10; i<inventoryA.length; i++)
		{
			if(inventoryA[i] != null)
			{	
				gi0 = inventoryA[i];
				str_array = gi0.split("-");
				System.out.println("       " + i + "       " + str_array[0] + "       " + str_array[1] + "        " + str_array[2] + "        " + str_array[3]);
			}
			else
			{
				System.out.println("No Weapon");
			}
		}*/
	}
	
	public void getItemInventory()
	{
		String gi1;
		String gi2;
		String gi3;
		String gi0;
		String[] str_array;
		int z;
		//displaySingleInv(0);		
		
		System.out.println("-#---Item Name--------------------------Description-----------------------------");
		
		for(int i = 0; i < 9; i++)
		{
			if(inventoryB[i] != null)
			{
				gi0 = inventoryB[i];
				str_array = gi0.split("_");
				z = i + 1;
				System.out.println(" " + z + "   " + str_array[0] + " " + str_array[1]);
			}
			else
			{
				System.out.println("No Item");
			}
		}
		for(int i = 9; i<inventoryB.length; i++)
		{
			if(inventoryB[i] != null)
			{
				gi0 = inventoryB[i];
				str_array = gi0.split("_");
				z = i + 1;
				System.out.println(" " + z + "  " + str_array[0] + " " + str_array[1]);
			}
			else
			{
				System.out.println("No Item");
			}
		}		
	}
	
	public int getWeaponAttack()
	{
		int watk3 = w1.getAtk();
		return watk3;
	}
	
	public int getWeaponStat()
	{
		int ws1 = w1.getStat();
		return ws1;
	}
	
	public int getWeaponSpeed()
	{
		int wspeed1 = w1.getSpeed();
		return wspeed1;
	}
	
	public String getStats()
	{
		return("Name: " + name + "\n" + "Health: " + health + "\n" + "Attack: " + attack + "\n" + "Attack with Weapon: " + totalatk + "\n" + "Defense: " + defense + "\n" + "Status: " + status + "\n" + "Exp: " + exp + "\n" + "Money: " + getCurrency() + "\n" + "Weapon: " + weaponName + "\n");
	}
	
	public void displaySingleInv(int i)
	{
		if(inventoryA[i] != null)
		{
			String gi1;
			String gi2;
			String gi3;
			String gi0 = inventoryA[i];
			String[] str_array = gi0.split("-");
			System.out.println("Currently Equipped...");
			System.out.println("Name: " + str_array[0] + "\nAttack: " + str_array[1] + "\nHealth: " + str_array[2] + "\nAttack Speed: " + str_array[3]);
			System.out.println("\n");
		}
	}
}