import java.awt.Point;
import java.io.Serializable;
import java.util.ArrayList;
     
public class Locations implements Serializable 
{
    private ArrayList<City> cityList = new ArrayList<>();
    private ArrayList<Town> townList = new ArrayList<>();
    private ArrayList<Village> villageList = new ArrayList<>();
    private ArrayList<ArrayList> locationList = new ArrayList<>();
    
    public Locations()
    {
        createList();
    }
    
    public final void createList()
    {
        createCityList();
        createTownList();
        createVillageList();
        addLocationsToList();
    }
    
    public final void createCityList()
    {
        ///////CITIES//////
        //0. Falconlake City - 652x389, 667x404
        //1. Snowwind City - 74x5, 89x20
        //2. Valdell City - 304x197, 319x212
        Point p01 = new Point(652,389);
        Point p02 = new Point(667,404);
        Point p11 = new Point(74,5);
        Point p12 = new Point(89,20);
        Point p21 = new Point(304,197);
        Point p22 = new Point(319,212);
        City c0 = new City("Falconlake City", 21, p01, p02);
        City c1 = new City("Snowwind City", 19, p11, p12);
        City c2 = new City("Valdell City", 17, p21, p22);
        cityList.add(c0);
        cityList.add(c1);
        cityList.add(c2);
        
    }
    
    public final void createTownList()
    {
        //        /////TOWNS//////
        //0. Aldpine - 582x60, 597x75
        //1. Brightbarrow - 111x386, 126x401
        //2. Deepmount - 92x179, 107x194
        //3. Greenhaven - 496x195, 511x210
        Point p01 = new Point(582,60);
        Point p02 = new Point(597,75);
        Point p11 = new Point(111,386);
        Point p12 = new Point(126,401);
        Point p21 = new Point(92,179);
        Point p22 = new Point(107,194);
        Point p31 = new Point(496,195);
        Point p32 = new Point(511,210);
        Town t0 = new Town("Aldpine", 12, p01, p02);
        Town t1 = new Town("Brightbarrow", 10, p11, p12);
        Town t2 = new Town("Deepmount", 14, p21, p22);
        Town t3 = new Town("Greenhaven", 9, p31, p32);
        townList.add(t0);
        townList.add(t1);
        townList.add(t2);
        townList.add(t3);
    }
    
    public final void createVillageList()
    {
        //        //////VILLAGES//////
        //0. Bluespring Village - 300x483, 315x498
        //1. Courtshore Village - 697x231, 712x246
        //2. Lordell Village - 79x524, 94x539
        //3. Woodmead Village - 752x18, 767x33
        Point p01 = new Point(300,483);
        Point p02 = new Point(315,498);
        Point p11 = new Point(695,230);
        Point p12 = new Point(715,245);
        Point p21 = new Point(79,524);
        Point p22 = new Point(94,539);
        Point p31 = new Point(752,18);
        Point p32 = new Point(767,33);
        Village v0 = new Village("Bluespring Village", 4, p01, p02);
        Village v1 = new Village("Courtshore Village", 5, p11, p12);
        Village v2 = new Village("Lordell Village", 3, p21, p22);
        Village v3 = new Village("Woodmead Village", 6, p31, p32);
        villageList.add(v0);
        villageList.add(v1);
        villageList.add(v2);
        villageList.add(v3);
    }
    
    public final void addLocationsToList()
    {
        locationList.add(cityList);
        locationList.add(townList);
        locationList.add(villageList);
    }
    
    public City getCity(int i)
    {
        return cityList.get(i);
    }
    
    public ArrayList<City> getCityList()
    {
        return cityList;
    }
    
    public ArrayList<Town> getTownList()
    {
        return townList;
    }
    
    public ArrayList<Village> getVillageList()
    {
        return villageList;
    }
    
    public Town getTown(int i)
    {
        return townList.get(i);
    }
    
    public Village getVillage(int i)
    {
        return villageList.get(i);
    }
    
    public ArrayList getLocationListItem(int i)
    {
        return locationList.get(i);
    }
    
    public ArrayList getLocationList()
    {
        return locationList;
    }
    
    public void setCity(City c, int i)
    {
        cityList.set(i, c);
    }
    
    public void setTown(Town t, int i)
    {
        townList.set(i, t);
    }
    
    public void setVillage(Village v, int i)
    {
        villageList.set(i, v);
    }
    
    public void setLocationList(ArrayList al, int i)
    {
        locationList.set(i, al);
    }
}
