import java.awt.Component;

import javax.swing.JOptionPane;
import java.io.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;
import javax.swing.JComboBox;

import javax.swing.JList;
import javax.swing.UIManager;
import javax.swing.plaf.basic.BasicComboBoxRenderer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author David
 */
public final class ExploreGUI extends javax.swing.JFrame {

    /**
     * Creates new form ExploreGUI
     */
	 
	private Locations l;
        ArrayList<Village> villages;
        ArrayList<Town> towns;
        ArrayList<City> cities;
        
	
    public ExploreGUI(Hero h)
    {
        l = h.getLocationObject();
        
		initComponents();
                specialTravel.setVisible(false);
                jTextArea3.setText(h.getTravels());
        visitStore.setEnabled(false);
        jTextArea1.append(h.getHeroStats());
        jTextArea2.append(h.displayCurrentWeapon());
        jTextField1.setText(h.getHeroPlace());
        hero = h;
        
        villages = l.getVillageList();
        towns = l.getTownList();
        cities = l.getCityList();
        refreshLocation();
        
        
    }
    
    //<editor-fold defaultstate="collapsed" desc="JCOMBOBOX Override">
    private class FullTownList extends JComboBox<Object>
    {
        @SuppressWarnings("unchecked")
        public FullTownList()
        {
            super();
            super.setRenderer(new FullTownListRenderer());
        }
        
        private Set<Object> disabled_items = new HashSet<>();
        
        public void addItem(Object anObject, boolean disabled)
        {
            super.addItem(anObject);
            if (disabled)
            {
                disabled_items.add(getItemCount() - 1);
            }
        }
        
        @Override
        public void removeAllItems()
        {
            super.removeAllItems();
            disabled_items = new HashSet<>();
        }
        
        @Override
        public void removeItemAt(final int anIndex)
        {
            super.removeItemAt(anIndex);
            disabled_items.remove(anIndex);
        }
        
        @Override
        public void removeItem(final Object anObject)
        {
            for (int i = 0; i < getItemCount(); i++)
            {
                if (getItemAt(i) == anObject)
                {
                    disabled_items.remove(i);
                }
            }
            super.removeItem(anObject);
        }
        
        @Override
        public void setSelectedIndex(int index)
        {
            if(!disabled_items.contains(index))
            {
                if(!disabled_items.contains(index))
                {
                    super.setSelectedIndex(index);
                }
            }
        }
        
        private class FullTownListRenderer extends BasicComboBoxRenderer
        {
            @Override
            public Component getListCellRendererComponent (JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
            {
                if (isSelected)
                {
                    setBackground(list.getSelectionBackground());
                    setForeground(list.getSelectionForeground());
                }
                else
                {
                    setBackground(list.getBackground());
                    setForeground(list.getForeground());
                }
                
                if (disabled_items.contains(index))
                {
                    setBackground(list.getBackground());
                    setForeground(UIManager.getColor("Label.disabledForeground"));
                }
                setFont(list.getFont());
                setText((value == null) ? "" : value.toString());
                return this;
            }
        }
    }//</editor-fold>

    public void refreshLocation()
    {
       townList.removeAllItems();
        String name;
        
        for(Village v : villages)
        {
            if(v.getVisited() == true)
            {
                name = v.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true);
            }
            else
            {
                townList.addItem(v.getName(), true);
            }
            
        }
        
       for(Town t : towns)
        {
            if(t.getVisited() == true)
            {
                name = t.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true);
   
            }
            else
            {
                townList.addItem(t.getName(), true);
            }
        }
       
       for(City c : cities)
        {
            if(c.getVisited() == true)
            {
                name = c.getName();
                townList.removeItem(name);
                townList.addItem(name); 
                visitStore.setEnabled(true);                
            }
            else
            {
                townList.addItem(c.getName(), true);
            }
        }
       if(!jTextField1.getText().equals(""))
       {
           visitStore.setEnabled(true);
       }
       else
       {
           visitStore.setEnabled(false);
       }
        switch (jTextField1.getText()) 
        {
            case "Courtshore Village":
            {
                specialTravel.setText("Take boat to Falconlake Island");
                specialTravel.setVisible(true);
                break;
            }
            case "Falconlake City":
            {
                specialTravel.setVisible(true);
                specialTravel.setText("Take boat to Courtshore Village");
                break;
            }
            default:
            {
                specialTravel.setText("");
                specialTravel.setVisible(false);
                break;
            }
        }
               
       
    }    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    
    //x = left , right ----- y = up, down
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        travel = new javax.swing.JButton();
        townList = new FullTownList();
        jLabel5 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        west = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        north = new javax.swing.JButton();
        south = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        east = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        visitStore = new javax.swing.JButton();
        viewMap = new javax.swing.JButton();
        checkInventory = new javax.swing.JButton();
        saveQuit = new javax.swing.JButton();
        clearBattleLog = new javax.swing.JButton();
        specialTravel = new javax.swing.JButton();
        save = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Explore - David's RPG");
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jPanel1KeyPressed(evt);
            }
        });

        jLabel4.setText("Use the direction buttons to move around.");

        travel.setText("Travel");
        travel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                travelActionPerformed(evt);
            }
        });

        townList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                townListActionPerformed(evt);
            }
        });

        jLabel5.setText("Travel to a different town:");

        jLabel3.setText("Explore the area:");
        jLabel3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel3MouseClicked(evt);
            }
        });

        west.setText("West");
        west.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                westActionPerformed(evt);
            }
        });

        jTextField1.setEditable(false);

        north.setText("North");
        north.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                northActionPerformed(evt);
            }
        });

        south.setText("South");
        south.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                southActionPerformed(evt);
            }
        });

        jTextArea3.setEditable(false);
        jTextArea3.setColumns(20);
        jTextArea3.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea3.setLineWrap(true);
        jTextArea3.setRows(5);
        jScrollPane3.setViewportView(jTextArea3);

        east.setText("East");
        east.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eastActionPerformed(evt);
            }
        });

        jLabel6.setText("You are currently in");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(townList, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(travel))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 177, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(north, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(west, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(east, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(south, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(34, 34, 34)
                                .addComponent(jLabel4)
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(14, 14, 14)
                                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 306, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))))))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addGap(167, 167, 167))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(north)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(west)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(east)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(south))
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(townList, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(travel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        visitStore.setText("Visit the Store");
        visitStore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                visitStoreActionPerformed(evt);
            }
        });

        viewMap.setText("View Map");
        viewMap.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewMapActionPerformed(evt);
            }
        });

        checkInventory.setText("Check Inventory");
        checkInventory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkInventoryActionPerformed(evt);
            }
        });

        saveQuit.setText("Save and Quit");
        saveQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveQuitActionPerformed(evt);
            }
        });

        clearBattleLog.setText("Clear Travel Log");
        clearBattleLog.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearBattleLogActionPerformed(evt);
            }
        });

        specialTravel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                specialTravelActionPerformed(evt);
            }
        });

        save.setText("Save Progress");
        save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(clearBattleLog, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(viewMap)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(visitStore)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(checkInventory)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(saveQuit))
                    .addComponent(specialTravel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(119, 119, 119)
                        .addComponent(save)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(save)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(visitStore)
                    .addComponent(checkInventory)
                    .addComponent(saveQuit)
                    .addComponent(viewMap))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(clearBattleLog)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(specialTravel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jLabel1.setText("Hero Stats");

        jLabel2.setText("Weapon Stats");
        jLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel2MouseClicked(evt);
            }
        });

        jTextArea2.setEditable(false);
        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea2.setLineWrap(true);
        jTextArea2.setRows(5);
        jScrollPane2.setViewportView(jTextArea2);

        jTextArea1.setEditable(false);
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(70, 70, 70))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(90, 90, 90))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void townListActionPerformed(java.awt.event.ActionEvent evt)
    {
        
    }
    
    private void northActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_northActionPerformed
        RDN rdnenc = new RDN(20);
        int rdenc = rdnenc.RN();
        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
        {
              startBattle();
//                
        }
        else
        {
            String move = hero.move("N");
            switch (move) 
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NWB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel north west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NEB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SWB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel south west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SEB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append(move + "\n");
                    break;
                }
            }
        }
        jTextField1.setText(hero.getHeroPlace());
        refreshLocation();
        randomLoot();
    }//GEN-LAST:event_northActionPerformed

    private void tListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_townListActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_townListActionPerformed

    private void eastActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eastActionPerformed
       RDN rdnenc = new RDN(20);
        int rdenc = rdnenc.RN();
        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
        {
              startBattle();
                
        }
        else
        {
            String move = hero.move("E");
            switch (move) 
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n.");
                    break;
                }
                case "NWB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel north west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NEB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SWB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel south west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SEB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append(move + "\n");
                    break;
                }
            }
        }
        jTextField1.setText(hero.getHeroPlace());
        refreshLocation();
        randomLoot();
    }//GEN-LAST:event_eastActionPerformed

    private void southActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_southActionPerformed
       RDN rdnenc = new RDN(20);
        int rdenc = rdnenc.RN();
        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
        {
              startBattle();
                
        }
                else
        {
            String move = hero.move("S");
            switch (move) 
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NWB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel north west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NEB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SWB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel south west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SEB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append(move + "\n");
                    break;
                }
            }
        }
        jTextField1.setText(hero.getHeroPlace());
        refreshLocation();
        randomLoot();
    }//GEN-LAST:event_southActionPerformed

    private void westActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_westActionPerformed
        RDN rdnenc = new RDN(20);
        int rdenc = rdnenc.RN();
        if (rdenc == 3 || rdenc == 7 || rdenc == 15 || rdenc == 12 || rdenc == 19)
        {
              startBattle();
                
        }
        else
        {
            String move = hero.move("W");
            switch (move) 
            {
                case "NB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "WB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "EB":
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NWB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel north west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "NEB":
                {
                    north.setEnabled(false);
                    south.setEnabled(true);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel north east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SWB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(true);
                    west.setEnabled(false);
                    jTextArea3.append("You cannot travel south west. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                case "SEB":
                {
                    north.setEnabled(true);
                    south.setEnabled(false);
                    east.setEnabled(false);
                    west.setEnabled(true);
                    jTextArea3.append("You cannot travel south east. The path is blocked.\nPlease travel in a different direction.\n");
                    break;
                }
                default:
                {
                    north.setEnabled(true);
                    south.setEnabled(true);
                    east.setEnabled(true);
                    west.setEnabled(true);
                    jTextArea3.append(move + "\n");
                    break;
                }
            }
        }
        jTextField1.setText(hero.getHeroPlace());
        refreshLocation();
        randomLoot();
    }//GEN-LAST:event_westActionPerformed

    public void randomLoot()
    {
        RDN r = new RDN(30);
        int rloot = r.RN();
        
        if(rloot == 5 || rloot == 21)
        {
            Item i = new Item(hero.getLevel());
            hero.addItem(i);
            jTextArea3.append("\n\n You tripped over something.\n You found a new item.\n" + i.getItemStats() + "\n\n");
        }
        
    }
    
    public void startBattle()
    {
        JOptionPane.showMessageDialog(null,"You have encountered a random enemy, prepare for battle.");
        jTextArea3.append("\nYou battled an enemy");
        String travels = jTextArea3.getText();
        
        hero.setTravels(travels);
              ExploreGUI.this.dispose();
              BattleGUI bg = new BattleGUI(hero);
              bg.setLocationRelativeTo(null);
              bg.setVisible(true);
    }
    
    private void saveQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveQuitActionPerformed
        String gs = hero.getName() + ".ser";
        ObjectOutputStream oos1;
        try
        {
            oos1 = new ObjectOutputStream (new FileOutputStream(gs));
            oos1.writeObject(hero);
            oos1.flush();
            oos1.close();
            String message = "The hero with the name " + hero.getName() + " has been saved with the filename " + gs + ".";
            JOptionPane.showMessageDialog(null,message);
            System.exit(0);
            
        }
        catch(IOException ioe)
        {
            
        }
        
    }//GEN-LAST:event_saveQuitActionPerformed

    private void checkInventoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkInventoryActionPerformed
              NewInventoryGUI ig = new NewInventoryGUI(hero);
              ig.setLocationRelativeTo(null);
              ig.setVisible(true);
              jTextArea2.setText(hero.displayCurrentWeapon());
              
    }//GEN-LAST:event_checkInventoryActionPerformed

    private void visitStoreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_visitStoreActionPerformed

              NewStoreGUI sg = new NewStoreGUI(hero, hero.getHeroPlace());
              sg.setLocationRelativeTo(null);
              sg.setVisible(true);
    }//GEN-LAST:event_visitStoreActionPerformed

    private void travelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_travelActionPerformed
        int town = townList.getSelectedIndex();
        Object tName = townList.getItemAt(town);
        String townName = tName.toString();
        hero.setHeroPlace(townName);
        hero.setHeroPlaceName(townName);
        jTextField1.setText(hero.getHeroPlace());
        refreshLocation();
    }//GEN-LAST:event_travelActionPerformed


    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       jTextArea2.setText(hero.displayCurrentWeapon());
       jTextArea1.setText(hero.getHeroStats());
       jTextField1.setText(hero.getHeroPlace());
    }//GEN-LAST:event_formWindowGainedFocus

    private void viewMapActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewMapActionPerformed
        MapGUI mg = new MapGUI(hero);
        mg.setLocationRelativeTo(null);
        mg.setVisible(true);
    }//GEN-LAST:event_viewMapActionPerformed

    private void jPanel1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jPanel1KeyPressed
    
       
//        
//        if (evt.getKeyCode() == KeyEvent.VK_F12)
//       {
//           ExploreGUI.this.dispose();
//              BattleGUI bg = new BattleGUI(hero);
//              bg.setLocationRelativeTo(null);
//              bg.setVisible(true);
//       }
    }//GEN-LAST:event_jPanel1KeyPressed

    private void jLabel3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel3MouseClicked
         
       
    }//GEN-LAST:event_jLabel3MouseClicked

    private void clearBattleLogActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearBattleLogActionPerformed
        jTextArea3.setText("");
        hero.setTravels("");
    }//GEN-LAST:event_clearBattleLogActionPerformed

    private void jLabel2MouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_jLabel2MouseClicked
    {//GEN-HEADEREND:event_jLabel2MouseClicked
        
           ExploreGUI.this.dispose();
              DebugMenuGUI dm = new DebugMenuGUI(hero);
              dm.setLocationRelativeTo(null);
              dm.setVisible(true);
    }//GEN-LAST:event_jLabel2MouseClicked

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    
        Object[] options = {"Quit Without Saving","Save and Quit", "Return to the Game"};
        int result = JOptionPane.showOptionDialog(null, "Are you sure you want to quit without saving?","Quit?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[2]);
       if(result == JOptionPane.OK_OPTION)
       {
           System.exit(0);
       }
       if(result == JOptionPane.NO_OPTION)
       {
           String gs = hero.getName() + ".ser";
        ObjectOutputStream oos1;
        try
        {
            oos1 = new ObjectOutputStream (new FileOutputStream(gs));
            oos1.writeObject(hero);
            oos1.flush();
            oos1.close();
            String message = "The hero with the name " + hero.getName() + " has been saved with the filename " + gs + ".";
            JOptionPane.showMessageDialog(null,message);
            System.exit(0);
            
        }
        catch(IOException ioe)
        {
            
        }
       }
    }//GEN-LAST:event_formWindowClosing

    private void specialTravelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_specialTravelActionPerformed
        if(specialTravel.getText().equals("Take boat to Falconlake Island"))
                {
                    hero.setHeroPlace("Falconlake City");
                    jTextField1.setText(hero.getHeroPlace());

                }
        if(specialTravel.getText().equals("Take boat to Courtshore Village"))
                {
                    hero.setHeroPlace("Courtshore Village");
                    jTextField1.setText(hero.getHeroPlace());
                }
        refreshLocation();
    }//GEN-LAST:event_specialTravelActionPerformed

    private void saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveActionPerformed
        String gs = hero.getName() + ".ser";
        ObjectOutputStream oos1;
        try
        {
            oos1 = new ObjectOutputStream (new FileOutputStream(gs));
            oos1.writeObject(hero);
            oos1.flush();
            oos1.close();
            String message = "The hero with the name " + hero.getName() + " has been saved with the filename " + gs + ".";
            JOptionPane.showMessageDialog(null,message);
            
            
        }
        catch(IOException ioe)
        {
            
        }
    }//GEN-LAST:event_saveActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ExploreGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
               // new ExploreGUI().setVisible(true);
            }
        });
    }
    
    
    private Hero hero;
	private FullTownList townList;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton checkInventory;
    private javax.swing.JButton clearBattleLog;
    private javax.swing.JButton east;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JButton north;
    private javax.swing.JButton save;
    private javax.swing.JButton saveQuit;
    private javax.swing.JButton south;
    private javax.swing.JButton specialTravel;
    /*
    private javax.swing.JComboBox townList;
    */
    private javax.swing.JButton travel;
    private javax.swing.JButton viewMap;
    private javax.swing.JButton visitStore;
    private javax.swing.JButton west;
    // End of variables declaration//GEN-END:variables
}
